//########## SEMANTIC VALUES ##########
package metropolis.metamodel.frontend.parser;

/**
 * Definitions of semantic values.
 * 
 * @see MetaModelParser
 * @version $Id: MetaModelParserval.java,v 1.4 2006/10/13 14:50:59 cxh Exp $
 */
public class MetaModelParserval implements Cloneable {
    /** Integer value. */
    public int ival;

    /** Double value. */
    public double dval;

    /** String value. */
    public String sval;

    /** Object. */
    public Object obj;

    /** Construct a MetaModelParserval. */
    public MetaModelParserval() {
    }

    /**
     * Construct a MetaModelParserval.
     * 
     * @param val
     *            Initial integer value.
     */
    public MetaModelParserval(int val) {
        ival = val;
    }

    /**
     * Construct a MetaModelParserval.
     * 
     * @param val
     *            Initial double value.
     */
    public MetaModelParserval(double val) {
        dval = val;
    }

    /**
     * Construct a MetaModelParserval.
     * 
     * @param val
     *            Initial String value.
     */
    public MetaModelParserval(String val) {
        sval = val;
    }

    /**
     * Construct a MetaModelParserval.
     * 
     * @param val
     *            Initial Object value.
     */
    public MetaModelParserval(Object val) {
        obj = val;
    }

    public Object clone() throws CloneNotSupportedException {
        return super.clone();
    }
}// end class
