//### This file created by BYACC 1.8(/Java extension  0.92)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//### Please send bug reports to rjamison@lincom-asg.com
//### static char yysccsid[] = "@(#)yaccpar        1.8 (Berkeley) 01/20/90";
//### Based on skeleton.c: $Id: MetaModelParser.java,v 1.6 2006/10/12 20:34:33 cxh Exp $
//###
//### This version of BYACC/Java has been modified by Jeff Tsay and
//### Christopher Brooks with the following changes:
//### 1) Parser values need to be cloned. Added a clone() method to the
//###    parser value class, and added a call the clone() method in the
//###    parser class.
//### 2) Parser tables are written to ASCII .tbl files instead of inlined
//###    in the parser class code. The reason for this is the 64KB limit
//###    on the size of .class files in Java. If .tbl files exist, the
//###    generated parser reads them and writes platform-independent
//###    binary .bin files, if the previous .bin files are older than
//###    the .tbl files or no .bin files are found.
//### 3) Added the -p option to set the package of the parser and parser
//###    value classes. Example:
//###
//###    ./ptbyacc -j -p ptolemy.lang.java -f JavaParser jparser.y
//###
//###    where jparser.y is the definition file.
//###
//### 4) If yydebug is set and yyrule.tbl is not present then
//###    you will get a NullPointerException because a debug() call
//###    dereferences yyrule[], which is null. (cxh)
//### 5) New instances of parserval are created for the return value of
//###    each rule, so that assignments to the fields of parserval do
//###    not corrupt previous data.
//### 6) To find the table files, we use the getSystemResource()
//###    facility to look in ptolemy/lang/java
//### Bob Jamison's version 0.93 fixes nil definitions, but the source
//### code was unavailable.
//###
//### This version of BYACC has been further modified in the Metropolis
//### project to reset the path were the table files should be found.
//### Currently it is set to metropolis/metamodel/frontend/parser
//###

//#line 179 "Grammar.y"
/*
 Meta-model parser produced by BYACC/J, with input file Grammar.y

 Copyright (c) 1998-2004 The Regents of the University of California.
 All rights reserved.

 Permission is hereby granted, without written agreement and without
 license or royalty fees, to use, copy, modify, and distribute this
 software and its documentation for any purpose, provided that the
 above copyright notice and the following two paragraphs appear in all
 copies of this software and that appropriate acknowledgments are made
 to the research of the Metropolis group.

 IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES
 ARISING OUT OF THE USE OF THIS SOFTWARE AND ITS DOCUMENTATION, EVEN IF
 THE UNIVERSITY OF CALIFORNIA HAS BEEN ADVISED OF THE POSSIBILITY OF
 SUCH DAMAGE.

 THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE SOFTWARE
 PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 CALIFORNIA HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.

 */

package metropolis.metamodel.frontend.parser;

import java.util.Iterator;
import java.util.List;
import java.util.LinkedList;
import java.util.Stack;
import java.io.IOException;
import java.io.FileInputStream;

import metropolis.metamodel.*;
import metropolis.metamodel.nodetypes.*;
import metropolis.metamodel.frontend.lexer.Lexer;

//#line 87 "MetaModelParser.java"
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.InputStreamReader;
import java.io.InputStream;
import java.io.File;
import java.io.FileReader;
import java.io.LineNumberReader;
import java.io.RandomAccessFile;
import java.io.Reader;
import java.io.StreamTokenizer;
import java.net.URL;

//#####################################################################
// class: MetaModelParser
/** Encapsulates yacc() parser functionality in a Java
 *  class for quick code development.
 *  This class is generated by ptbyacc, which is based on byacc
 *  by Bob Jamison.
 *  byacc has a Sourceforge page at
 *  <a href="http://byaccj.sourceforge.net">http://byaccj.sourceforge.net</a>.
 *  byacc is in the public domain.
 *  @version $Id: MetaModelParser.java,v 1.6 2006/10/12 20:34:33 cxh Exp $
 */
public class MetaModelParser {

    /** True if debug output is generated. */
    public boolean yydebug;

    /** Number of errors thus far. */
    int yynerrs;

    /** Was there an error? */
    int yyerrflag;

    /** The current working character. */
    int yychar;

    //########## MESSAGES ##########
    //###############################################################
    // method: debug
    //###############################################################
    void debug(String msg) {
        if (yydebug)
            System.out.println(msg);
    }

    //########## STATE STACK ##########
    final static int YYSTACKSIZE = 500; //maximum stack size

    int statestk[], stateptr; //state stack
            //###############################################################
            // methods: state stack push,pop,drop,peek
            //###############################################################

    void state_push(int state) {
        if (stateptr >= YYSTACKSIZE) //overflowed?
            return;
        statestk[++stateptr] = state;
    }

    int state_pop() {
        if (stateptr < 0) //underflowed?
            return -1;
        return statestk[stateptr--];
    }

    void state_drop(int cnt) {
        int ptr;
        ptr = stateptr - cnt;
        if (ptr < 0)
            return;
        stateptr = ptr;
    }

    int state_peek(int relative) {
        int ptr;
        ptr = stateptr - relative;
        if (ptr < 0)
            return -1;
        return statestk[ptr];
    }

    //###############################################################
    // method: init_stacks : allocate and prepare stacks
    //###############################################################
    boolean init_stacks() {
        statestk = new int[YYSTACKSIZE];
        stateptr = -1;
        val_init();
        return true;
    }

    //###############################################################
    // method: dump_stacks : show n levels of the stacks
    //###############################################################
    // void dump_stacks(int count)
    // {
    // int i;
    //   System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
    //   for (i=0;i<count;i++)
    //     System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
    //   System.out.println("======================");
    //   }
    // Read in a table of shorts.
    // The tables are in two formats, a binary format and a text format.
    // To find the data, we use resources to look in the current
    // directory first for a .bin file, then for a .tbl file.
    // If the .bin file is not present, but the .tbl file is present,
    // then we write out the .bin file for use next time.
    static short[] read_short_table(String filename, int size) {
        ClassLoader myClassLoader = _getMyClassLoader();
        short[] retval = new short[size];

        // Try reading the file in binary format.
        InputStream binaryInputStream = myClassLoader
                .getResourceAsStream("metropolis/metamodel/frontend/parser/"
                        + filename + ".bin");
        if (binaryInputStream != null) {
            try {
                // We found the .bin file, now go get the data.
                DataInputStream binaryDataInput = new DataInputStream(
                        binaryInputStream);
                for (int i = 0; i < size; i++) {
                    retval[i] = binaryDataInput.readShort();
                }
                binaryDataInput.close();
                return retval;
            } catch (IOException e) {
                // Just read the text table instead if an I/O error occurs.
            }
        }

        // Try reading the file in text format.
        // For Ptolemy II, the tables should be in $PTII/ptolemy/lang/java
        InputStream tableInputStream = myClassLoader
                .getResourceAsStream("metropolis/metamodel/frontend/parser/"
                        + filename + ".tbl");
        if (tableInputStream == null) {
            throw new RuntimeException("No tables for " + filename
                    + " could be found, could not find\n"
                    + "'metropolis/metamodel/frontend/parser/" + filename
                    + ".tbl'\nas a resource " + "using the ClassLoader "
                    + myClassLoader.getClass().getName());
        }

        // "As of JDK version 1.1, the preferred way to tokenize an input stream
        // is to convert it into a character stream"

        Reader reader = new BufferedReader(new InputStreamReader(
                tableInputStream));
        StreamTokenizer tokenizer = new StreamTokenizer(reader);
        for (int i = 0; i < size; i++) {
            try {
                tokenizer.nextToken();
            } catch (IOException e) {
                throw new RuntimeException(filename
                        + " does not contain enough entries");
            }
            // This shouldn't happen if we didn't call
            //  parseNumbers() - BUG in JDK 1.2.1
            retval[i] = (short) tokenizer.nval;
        }
        try {
            reader.close();
        } catch (IOException e) {
            throw new RuntimeException(filename + " could not be closed");
        }

        // Write out the table in binary format for next time.
        // In the perfect world, we would like to write to a URL,
        // but instead we just write to the current directory.
        // Note that this will cause problems if we are running this
        // as an applet.  I tried writing to a URL as per
        // http://www.javasoft.com/docs/books/tutorial/networking/urls/readingWriting.html
        // but got
        // "java.net.UnknownServiceException: protocol doesn't support output"

        // Try to put the .bin file in the parser directory
        File binFile = null;
        try {
            // We might be in the Swing Event thread, so
            // Thread.currentThread().getContextClassLoader()
            // .getResource(entry) probably will not work.
            URL metaModelParserURL = myClassLoader
                    .getResource("metropolis/metamodel/frontend/parser/MetaModelParser.class");
            File metaModelParserFile = new File(metaModelParserURL.getFile());
            binFile = new File(metaModelParserFile.getParent(), filename
                    + ".bin");

        } catch (Exception ex) {
            System.err.println("Could not write .bin file in "
                    + "metropolis/metamodel/frontend/parser/:" + ex);
            binFile = new File(filename + ".bin");
        }

        try {
            RandomAccessFile rafOut = new RandomAccessFile(binFile, "rw");
            for (int i = 0; i < size; i++) {
                rafOut.writeShort(retval[i]);
            }
            rafOut.close();
        } catch (IOException e) {
            System.err.println("Warning: could not write binary table to "
                    + binFile + ": " + e);
        }

        return retval;
    }

    // Get the ClassLoader that loaded this class.
    static private ClassLoader _getMyClassLoader() {
        class ClassLoaderFinder extends SecurityManager {
            public ClassLoader getParentsClassLoader() {
                return getClassContext()[1].getClassLoader();
            }
        }
        return new ClassLoaderFinder().getParentsClassLoader();
    }

    // read_string_table is only used if we run with yydebug != 0
    static String[] read_string_table(String filename, int size) {
        FileReader fileReader = null;
        try {
            fileReader = new FileReader(filename);
        } catch (IOException e) {
            return null; // hide error if we delete this non-critical table
        }
        LineNumberReader lineReader = new LineNumberReader(fileReader);
        String[] retval = new String[size];
        for (int i = 0; i < size; i++) {
            try {
                retval[i] = lineReader.readLine();
            } catch (IOException e) {
                throw new RuntimeException(filename
                        + "does not contain enough entries");
            }
        }
        try {
            fileReader.close();
        } catch (IOException e) {
            throw new RuntimeException(filename + " could not be closed");
        }
        return retval;
    }

    //########## SEMANTIC VALUES ##########
    //public class MetaModelParsersemantic is defined in MetaModelParserval.java

    String yytext;//user variable to return contextual strings

    MetaModelParserval yyval; //used to return semantic vals from action routines

    MetaModelParserval yylval;//the 'lval' (result) I got from yylex()

    MetaModelParserval valstk[];

    int valptr;

    //###############################################################
    // methods: value stack push,pop,drop,peek.
    //###############################################################
    void val_init() {
        valstk = new MetaModelParserval[YYSTACKSIZE];
        yyval = new MetaModelParserval(0);
        yylval = new MetaModelParserval(0);
        valptr = -1;
    }

    void val_push(MetaModelParserval val) {
        if (valptr >= YYSTACKSIZE)
            return;
        valstk[++valptr] = val;
    }

    MetaModelParserval val_pop() {
        if (valptr < 0)
            return new MetaModelParserval(-1);
        return valstk[valptr--];
    }

    void val_drop(int cnt) {
        int ptr;
        ptr = valptr - cnt;
        if (ptr < 0)
            return;
        valptr = ptr;
    }

    MetaModelParserval val_peek(int relative) {
        int ptr;
        ptr = valptr - relative;
        if (ptr < 0)
            return new MetaModelParserval(-1);
        return valstk[ptr];
    }

    //#### end semantic value section ####
    /** ABSTRACT Token value.*/
    public final static short ABSTRACT = 257;

    /** ADDCOMPONENT Token value.*/
    public final static short ADDCOMPONENT = 258;

    /** ALL Token value.*/
    public final static short ALL = 259;

    /** AT Token value.*/
    public final static short AT = 260;

    /** AWAIT Token value.*/
    public final static short AWAIT = 261;

    /** BEG Token value.*/
    public final static short BEG = 262;

    /** BLACKBOX Token value.*/
    public final static short BLACKBOX = 263;

    /** BLOCK Token value.*/
    public final static short BLOCK = 264;

    /** BOOLEAN Token value.*/
    public final static short BOOLEAN = 265;

    /** BOUNDEDLOOP Token value.*/
    public final static short BOUNDEDLOOP = 266;

    /** BREAK Token value.*/
    public final static short BREAK = 267;

    /** BYTE Token value.*/
    public final static short BYTE = 268;

    /** CASE Token value.*/
    public final static short CASE = 269;

    /** CHAR Token value.*/
    public final static short CHAR = 270;

    /** CLASS Token value.*/
    public final static short CLASS = 271;

    /** CONNECT Token value.*/
    public final static short CONNECT = 272;

    /** CONSTANT Token value.*/
    public final static short CONSTANT = 273;

    /** CONSTRAINT Token value.*/
    public final static short CONSTRAINT = 274;

    /** CONTINUE Token value.*/
    public final static short CONTINUE = 275;

    /** DEFAULT Token value.*/
    public final static short DEFAULT = 276;

    /** DO Token value.*/
    public final static short DO = 277;

    /** DOUBLE Token value.*/
    public final static short DOUBLE = 278;

    /** ELABORATE Token value.*/
    public final static short ELABORATE = 279;

    /** ELOC Token value.*/
    public final static short ELOC = 280;

    /** ELSE Token value.*/
    public final static short ELSE = 281;

    /** END Token value.*/
    public final static short END = 282;

    /** EVAL Token value.*/
    public final static short EVAL = 283;

    /** EVENT Token value.*/
    public final static short EVENT = 284;

    /** EXCL Token value.*/
    public final static short EXCL = 285;

    /** EXECINDEX Token value.*/
    public final static short EXECINDEX = 286;

    /** EXISTS Token value.*/
    public final static short EXISTS = 287;

    /** EXTENDS Token value.*/
    public final static short EXTENDS = 288;

    /** F Token value.*/
    public final static short F = 289;

    /** FINAL Token value.*/
    public final static short FINAL = 290;

    /** FLOAT Token value.*/
    public final static short FLOAT = 291;

    /** FOR Token value.*/
    public final static short FOR = 292;

    /** FORALL Token value.*/
    public final static short FORALL = 293;

    /** G Token value.*/
    public final static short G = 294;

    /** GETCOMPNAME Token value.*/
    public final static short GETCOMPNAME = 295;

    /** GETCONNECTIONNUM Token value.*/
    public final static short GETCONNECTIONNUM = 296;

    /** GETNTHCONNECTIONSRC Token value.*/
    public final static short GETNTHCONNECTIONSRC = 297;

    /** GETNTHCONNECTIONPORT Token value.*/
    public final static short GETNTHCONNECTIONPORT = 298;

    /** GETCOMPONENT Token value.*/
    public final static short GETCOMPONENT = 299;

    /** GETCONNECTIONDEST Token value.*/
    public final static short GETCONNECTIONDEST = 300;

    /** GETINSTNAME Token value.*/
    public final static short GETINSTNAME = 301;

    /** GETNTHPORT Token value.*/
    public final static short GETNTHPORT = 302;

    /** GETPORTNUM Token value.*/
    public final static short GETPORTNUM = 303;

    /** GETPROCESS Token value.*/
    public final static short GETPROCESS = 304;

    /** GETSCOPE Token value.*/
    public final static short GETSCOPE = 305;

    /** GETTHREAD Token value.*/
    public final static short GETTHREAD = 306;

    /** GETTYPE Token value.*/
    public final static short GETTYPE = 307;

    /** IF Token value.*/
    public final static short IF = 308;

    /** IMPLEMENTS Token value.*/
    public final static short IMPLEMENTS = 309;

    /** IMPORT Token value.*/
    public final static short IMPORT = 310;

    /** INSTANCEOF Token value.*/
    public final static short INSTANCEOF = 311;

    /** INT Token value.*/
    public final static short INT = 312;

    /** INTERFACE Token value.*/
    public final static short INTERFACE = 313;

    /** ISCONNECTIONREFINED Token value.*/
    public final static short ISCONNECTIONREFINED = 314;

    /** LABEL Token value.*/
    public final static short LABEL = 315;

    /** LAST Token value.*/
    public final static short LAST = 316;

    /** LFO Token value.*/
    public final static short LFO = 317;

    /** LOC Token value.*/
    public final static short LOC = 318;

    /** LONG Token value.*/
    public final static short LONG = 319;

    /** LTL Token value.*/
    public final static short LTL = 320;

    /** MAXDELTA Token value.*/
    public final static short MAXDELTA = 321;

    /** MINDELTA Token value.*/
    public final static short MINDELTA = 322;

    /** MAXRATE Token value.*/
    public final static short MAXRATE = 323;

    /** MINRATE Token value.*/
    public final static short MINRATE = 324;

    /** PERIOD Token value.*/
    public final static short PERIOD = 325;

    /** MEDIUM Token value.*/
    public final static short MEDIUM = 326;

    /** MUTEX Token value.*/
    public final static short MUTEX = 327;

    /** NETLIST Token value.*/
    public final static short NETLIST = 328;

    /** NEW Token value.*/
    public final static short NEW = 329;

    /** NONDETERMINISM Token value.*/
    public final static short NONDETERMINISM = 330;

    /** NONE Token value.*/
    public final static short NONE = 331;

    /** _NULL Token value.*/
    public final static short _NULL = 332;

    /** OTHER Token value.*/
    public final static short OTHER = 333;

    /** PACKAGE Token value.*/
    public final static short PACKAGE = 334;

    /** PARAMETER Token value.*/
    public final static short PARAMETER = 335;

    /** PC Token value.*/
    public final static short PC = 336;

    /** PCVAL Token value.*/
    public final static short PCVAL = 337;

    /** PORT Token value.*/
    public final static short PORT = 338;

    /** PRIORITY Token value.*/
    public final static short PRIORITY = 339;

    /** PRIVATE Token value.*/
    public final static short PRIVATE = 340;

    /** PROCESS Token value.*/
    public final static short PROCESS = 341;

    /** PROTECTED Token value.*/
    public final static short PROTECTED = 342;

    /** PUBLIC Token value.*/
    public final static short PUBLIC = 343;

    /** QUANTITY Token value.*/
    public final static short QUANTITY = 344;

    /** REDIRECTCONNECT Token value.*/
    public final static short REDIRECTCONNECT = 345;

    /** REFINE Token value.*/
    public final static short REFINE = 346;

    /** REFINECONNECT Token value.*/
    public final static short REFINECONNECT = 347;

    /** RETVAL Token value.*/
    public final static short RETVAL = 348;

    /** RETURN Token value.*/
    public final static short RETURN = 349;

    /** SCHEDULER Token value.*/
    public final static short SCHEDULER = 350;

    /** SETSCOPE Token value.*/
    public final static short SETSCOPE = 351;

    /** SHORT Token value.*/
    public final static short SHORT = 352;

    /** SIMUL Token value.*/
    public final static short SIMUL = 353;

    /** STATEMEDIUM Token value.*/
    public final static short STATEMEDIUM = 354;

    /** STATIC Token value.*/
    public final static short STATIC = 355;

    /** SUPER Token value.*/
    public final static short SUPER = 356;

    /** SWITCH Token value.*/
    public final static short SWITCH = 357;

    /** SYNCH Token value.*/
    public final static short SYNCH = 358;

    /** TEMPLATE Token value.*/
    public final static short TEMPLATE = 359;

    /** THIS Token value.*/
    public final static short THIS = 360;

    /** U Token value.*/
    public final static short U = 361;

    /** UPDATE Token value.*/
    public final static short UPDATE = 362;

    /** USEPORT Token value.*/
    public final static short USEPORT = 363;

    /** VOID Token value.*/
    public final static short VOID = 364;

    /** WHILE Token value.*/
    public final static short WHILE = 365;

    /** X Token value.*/
    public final static short X = 366;

    /** CATCH Token value.*/
    public final static short CATCH = 367;

    /** CONST Token value.*/
    public final static short CONST = 368;

    /** FINALLY Token value.*/
    public final static short FINALLY = 369;

    /** GOTO Token value.*/
    public final static short GOTO = 370;

    /** NATIVE Token value.*/
    public final static short NATIVE = 371;

    /** STRICTFP Token value.*/
    public final static short STRICTFP = 372;

    /** SYNCHRONIZED Token value.*/
    public final static short SYNCHRONIZED = 373;

    /** THROW Token value.*/
    public final static short THROW = 374;

    /** THROWS Token value.*/
    public final static short THROWS = 375;

    /** TRANSIENT Token value.*/
    public final static short TRANSIENT = 376;

    /** TRY Token value.*/
    public final static short TRY = 377;

    /** VOLATILE Token value.*/
    public final static short VOLATILE = 378;

    /** TRUE Token value.*/
    public final static short TRUE = 379;

    /** FALSE Token value.*/
    public final static short FALSE = 380;

    /** IDENTIFIER Token value.*/
    public final static short IDENTIFIER = 381;

    /** BLACKBOX_CONTENT Token value.*/
    public final static short BLACKBOX_CONTENT = 382;

    /** INT_LITERAL Token value.*/
    public final static short INT_LITERAL = 383;

    /** LONG_LITERAL Token value.*/
    public final static short LONG_LITERAL = 384;

    /** FLOAT_LITERAL Token value.*/
    public final static short FLOAT_LITERAL = 385;

    /** DOUBLE_LITERAL Token value.*/
    public final static short DOUBLE_LITERAL = 386;

    /** CHARACTER_LITERAL Token value.*/
    public final static short CHARACTER_LITERAL = 387;

    /** STRING_LITERAL Token value.*/
    public final static short STRING_LITERAL = 388;

    /** BEGIN_TEMPLATE Token value.*/
    public final static short BEGIN_TEMPLATE = 389;

    /** END_TEMPLATE Token value.*/
    public final static short END_TEMPLATE = 390;

    /** BEGIN_LABEL Token value.*/
    public final static short BEGIN_LABEL = 391;

    /** END_LABEL Token value.*/
    public final static short END_LABEL = 392;

    /** BEGIN_ANNOTATION Token value.*/
    public final static short BEGIN_ANNOTATION = 393;

    /** END_ANNOTATION Token value.*/
    public final static short END_ANNOTATION = 394;

    /** EMPTY_DIM Token value.*/
    public final static short EMPTY_DIM = 395;

    /** IMPLY Token value.*/
    public final static short IMPLY = 396;

    /** CAND Token value.*/
    public final static short CAND = 397;

    /** COR Token value.*/
    public final static short COR = 398;

    /** CIF Token value.*/
    public final static short CIF = 399;

    /** CIFF Token value.*/
    public final static short CIFF = 400;

    /** EQ Token value.*/
    public final static short EQ = 401;

    /** NE Token value.*/
    public final static short NE = 402;

    /** LE Token value.*/
    public final static short LE = 403;

    /** GE Token value.*/
    public final static short GE = 404;

    /** LSHIFTL Token value.*/
    public final static short LSHIFTL = 405;

    /** ASHIFTR Token value.*/
    public final static short ASHIFTR = 406;

    /** LSHIFTR Token value.*/
    public final static short LSHIFTR = 407;

    /** PLUS_ASG Token value.*/
    public final static short PLUS_ASG = 408;

    /** MINUS_ASG Token value.*/
    public final static short MINUS_ASG = 409;

    /** MULT_ASG Token value.*/
    public final static short MULT_ASG = 410;

    /** DIV_ASG Token value.*/
    public final static short DIV_ASG = 411;

    /** REM_ASG Token value.*/
    public final static short REM_ASG = 412;

    /** LSHIFTL_ASG Token value.*/
    public final static short LSHIFTL_ASG = 413;

    /** ASHIFTR_ASG Token value.*/
    public final static short ASHIFTR_ASG = 414;

    /** LSHIFTR_ASG Token value.*/
    public final static short LSHIFTR_ASG = 415;

    /** AND_ASG Token value.*/
    public final static short AND_ASG = 416;

    /** XOR_ASG Token value.*/
    public final static short XOR_ASG = 417;

    /** OR_ASG Token value.*/
    public final static short OR_ASG = 418;

    /** PLUSPLUS Token value.*/
    public final static short PLUSPLUS = 419;

    /** MINUSMINUS Token value.*/
    public final static short MINUSMINUS = 420;

    /** YYERRCODE Token value.*/
    public final static short YYERRCODE = 256;

    final static int NRULES = 644;

    final static short yylhs[] = read_short_table("yylhs", NRULES - 2);

    final static short yylen[] = read_short_table("yylen", NRULES - 2);

    final static int NSTATES = 1424;

    final static short yydefred[] = read_short_table("yydefred", NSTATES);

    final static int YYDGOTOSIZE = 254;

    final static short yydgoto[] = read_short_table("yydgoto", YYDGOTOSIZE);

    final static short yysindex[] = read_short_table("yysindex", NSTATES);

    final static short yyrindex[] = read_short_table("yyrindex", NSTATES);

    final static int YYGINDEXSIZE = 254;

    final static short yygindex[] = read_short_table("yygindex", YYGINDEXSIZE);

    final static int YYTABLESIZE = 16251;

    final static short yytable[] = read_short_table("yytable", YYTABLESIZE + 1);

    final static short yycheck[] = read_short_table("yycheck", YYTABLESIZE + 1);

    final static short YYFINAL = 3;

    final static short YYMAXTOKEN = 420;

    final static String yyname[] = { "end-of-file", null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, "'!'", null, null, null, "'%'",
            "'&'", null, "'('", "')'", "'*'", "'+'", "','", "'-'", "'.'",
            "'/'", null, null, null, null, null, null, null, null, null, null,
            "':'", "';'", "'<'", "'='", "'>'", "'?'", null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, "'['", null, "']'", "'^'", null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, "'{'", "'|'", "'}'", "'~'", null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, null, null, null, null, null, null, null,
            null, null, null, null, "ABSTRACT", "ADDCOMPONENT", "ALL", "AT",
            "AWAIT", "BEG", "BLACKBOX", "BLOCK", "BOOLEAN", "BOUNDEDLOOP",
            "BREAK", "BYTE", "CASE", "CHAR", "CLASS", "CONNECT", "CONSTANT",
            "CONSTRAINT", "CONTINUE", "DEFAULT", "DO", "DOUBLE", "ELABORATE",
            "ELOC", "ELSE", "END", "EVAL", "EVENT", "EXCL", "EXECINDEX",
            "EXISTS", "EXTENDS", "F", "FINAL", "FLOAT", "FOR", "FORALL", "G",
            "GETCOMPNAME", "GETCONNECTIONNUM", "GETNTHCONNECTIONSRC",
            "GETNTHCONNECTIONPORT", "GETCOMPONENT", "GETCONNECTIONDEST",
            "GETINSTNAME", "GETNTHPORT", "GETPORTNUM", "GETPROCESS",
            "GETSCOPE", "GETTHREAD", "GETTYPE", "IF", "IMPLEMENTS", "IMPORT",
            "INSTANCEOF", "INT", "INTERFACE", "ISCONNECTIONREFINED", "LABEL",
            "LAST", "LFO", "LOC", "LONG", "LTL", "MAXDELTA", "MINDELTA",
            "MAXRATE", "MINRATE", "PERIOD", "MEDIUM", "MUTEX", "NETLIST",
            "NEW", "NONDETERMINISM", "NONE", "_NULL", "OTHER", "PACKAGE",
            "PARAMETER", "PC", "PCVAL", "PORT", "PRIORITY", "PRIVATE",
            "PROCESS", "PROTECTED", "PUBLIC", "QUANTITY", "REDIRECTCONNECT",
            "REFINE", "REFINECONNECT", "RETVAL", "RETURN", "SCHEDULER",
            "SETSCOPE", "SHORT", "SIMUL", "STATEMEDIUM", "STATIC", "SUPER",
            "SWITCH", "SYNCH", "TEMPLATE", "THIS", "U", "UPDATE", "USEPORT",
            "VOID", "WHILE", "X", "CATCH", "CONST", "FINALLY", "GOTO",
            "NATIVE", "STRICTFP", "SYNCHRONIZED", "THROW", "THROWS",
            "TRANSIENT", "TRY", "VOLATILE", "TRUE", "FALSE", "IDENTIFIER",
            "BLACKBOX_CONTENT", "INT_LITERAL", "LONG_LITERAL", "FLOAT_LITERAL",
            "DOUBLE_LITERAL", "CHARACTER_LITERAL", "STRING_LITERAL",
            "BEGIN_TEMPLATE", "END_TEMPLATE", "BEGIN_LABEL", "END_LABEL",
            "BEGIN_ANNOTATION", "END_ANNOTATION", "EMPTY_DIM", "IMPLY", "CAND",
            "COR", "CIF", "CIFF", "EQ", "NE", "LE", "GE", "LSHIFTL", "ASHIFTR",
            "LSHIFTR", "PLUS_ASG", "MINUS_ASG", "MULT_ASG", "DIV_ASG",
            "REM_ASG", "LSHIFTL_ASG", "ASHIFTR_ASG", "LSHIFTR_ASG", "AND_ASG",
            "XOR_ASG", "OR_ASG", "PLUSPLUS", "MINUSMINUS", };

    //#line 4074 "Grammar.y"

    /** Initialize the lexical analyzer.
     *  @param filename The file to parse, which must be suitable
     *  for FileInputStream().
     *  @exception IOException If creating a FileInputStream throws it.
     */
    public void init(String filename) throws IOException {
        _filename = filename;
        _lexer = new Lexer(new FileInputStream(_filename));
    }

    /** Parse the input.
     *  @return 1 if there is a problem, 0 if there is no problem.
     */
    public int parse() {
        _numErrors = 0;
        int result = yyparse();
        if (_numErrors > 0)
            throw new RuntimeException(
                    "There are syntactic errors, check messages " + "above.");
        return result;
    }

    /** Get the next token.
     *  @return The next token.
     */
    protected int yylex() {
        int _retval;

        try {
            _retval = _lexer.yylex();

            yylval = _lexer.getMetaModelParserval();

        } catch (IOException ex) {
            throw new RuntimeException("lexical error", ex);
        }

        return _retval;
    }

    /** Create a new list with the obj as the contents of the list.
     * @param obj The object to insert into the list.
     * @return The new list.
     */
    protected static final List cons(Object obj) {
        return cons(obj, new LinkedList());
    }

    /** Insert an object to the head of a list.
     *  The object must be non-null and must not be
     *  an instance of AbsentTreeNode.  If it is null or
     *  an instance of AbsentTreeNode, then the list is unchanged
     *  @param obj The Object to insert.
     *  @param list The list to which the object is inserted.
     *  @return the list
     */
    protected static final List cons(Object obj, List list) {
        if ((obj != null) && (obj != AbsentTreeNode.instance)) {
            list.add(0, obj);
        }

        return list;
    }

    /** Append an object to the end of a preexisting list.
     *  @param obj The Object to append
     *  @param list The list to which the object is appended.
     *  @return the list
     */
    protected static final List append(List list, Object obj) {
        list.add(obj);
        return list;
    }

    /** Append list2 on list1.
     *  @param list1 The list that gets appended to.
     *  @param list2 The list that gets appended.
     *  @return list1
     */
    protected static final List appendLists(List list1, List list2) {
        list1.addAll(list2);
        return list1;
    }

    /** Return the qualified name of a node.
     *  @param node The NameNode we are looking up.
     *  @return The qualified name.
     */
    protected static final String qualifiedName(NameNode node) {
        String result;
        String ident = node.getIdent();
        TreeNode qualifier = node.getQualifier();
        if (qualifier == AbsentTreeNode.instance) {
            result = ident;
        } else {
            result = qualifiedName((NameNode) qualifier) + "." + ident;
        }
        return result;
    }

    /** Check that all classes have at least one constructor. If no constructor
     *  is found, create one constructor with no arguments that calls the
     *  default constructor in the superclass.
     *  @param name    The name of the type.
     *  @param members The list of members of the type.
     *  @param hasNameInCntr True if there is no constructor that takes a
     *  name argument.
     */
    protected static final void forceOneConstructor(NameNode name,
            List members, boolean hasNameInCntr) {
        Iterator memberItr = members.iterator();
        while (memberItr.hasNext()) {
            Object member = memberItr.next();
            if (member instanceof ConstructorDeclNode) {
                // Constructor found
                return;
            }
        }

        // There is no constructor.
        // We will create a public constructor with no arguments and a call
        // to the superclass constructor, also with no arguments
        if (!hasNameInCntr) {
            try {
                name = (NameNode) name.clone();
            } catch (CloneNotSupportedException ex) {
                throw new RuntimeException("Clone of '" + name
                        + "' not supported.", ex);
            }
            int modifier = Modifier.PUBLIC_MOD;
            List params = new LinkedList();
            BlockNode block = new BlockNode(new LinkedList());
            LinkedList par = new LinkedList();
            SuperConstructorCallNode call = new SuperConstructorCallNode(par);

            ConstructorDeclNode constr = new ConstructorDeclNode(modifier,
                    name, params, block, call);

            // Add the constructor to the body of the list of members
            members.add(constr);
        }

        // If this is for process, medium, scheduler or
        // netlist, we will create another public constructor
        // with an "String name" arguments and a call to the
        // superclass constructor, also with the name arguments.

        if (hasNameInCntr) {
            try {
                name = (NameNode) name.clone();
            } catch (CloneNotSupportedException ex) {
                throw new RuntimeException("Clone of '" + (NameNode) name
                        + "' not supported.", ex);
            }
            int modifier = Modifier.PUBLIC_MOD;
            List params = new LinkedList();
            BlockNode block = new BlockNode(new LinkedList());
            LinkedList par = new LinkedList();
            NameNode type = new NameNode(AbsentTreeNode.instance, new String(
                    "String"), AbsentTreeNode.instance);
            NameNode nm = new NameNode(AbsentTreeNode.instance, new String(
                    "name"), AbsentTreeNode.instance);
            TypeNameNode typeName = new TypeNameNode(type);
            ParameterNode param = new ParameterNode(0, typeName, nm);
            params.add(param);
            try {
                par.add(new ObjectNode((NameNode) nm.clone()));
            } catch (CloneNotSupportedException ex) {
                throw new RuntimeException("Clone of '" + (NameNode) nm
                        + "' not supported.", ex);
            }
            SuperConstructorCallNode call = new SuperConstructorCallNode(par);

            ConstructorDeclNode constr = new ConstructorDeclNode(modifier,
                    name, params, block, call);

            // Add the constructor to the body of the list
            // of members

            members.add(constr);
        }
    }

    /** Store _lexer.lineNumber for later retrieval after returning to the same
     *  level in the parse tree.
     *  @param tag a String to use to verify that your pushes & pops haven't
     *  gotten out of sync.
     */
    protected void pushCurrentLineNumber(String tag) {
        _lineNumberStack.push(new Integer(_lexer.lineNumber()));
        _lineNumberTagStack.push(tag);
        // For backwards compatability with parts of this code that use
        // _inLineNumber.
        //_inLineNumber = _lexer.lineNumber();
    }

    /** Pop a line number off the stack (as an Integer), previously stored there
     *  by {@link #pushCurrentLineNumber(String)}.
     *  @param tag a String to use to verify that your pushes & pops haven't
     *  gotten out of sync.
     *  @return The current line number.
     */
    protected Integer popCurrentLineNumber(String tag) {
        String check = (String) _lineNumberTagStack.pop();
        if ((check == null && tag != null) || !check.equals(tag)) {
            _lineNumberStack.pop();
            yyerror("Internal grammar error: tag \"" + tag
                    + "\" does not equal check string on line-number stack (\""
                    + check + "\")");
            return new Integer(0);
        } else {
            return (Integer) _lineNumberStack.pop();
        }
    }

    /** A separate version of {@link #pushCurrentLineNumber(String)} for
     *  the do-while-loop, which needs not only the line number of the "do"
     *  line, but also that of the "while" test.
     *  @param tag a String to use to verify that your pushes & pops haven't
     *  gotten out of sync.
     */
    protected void pushDoLoopTestLineNumber(String tag) {
        _doLoopLineNumberStack.push(new Integer(_lexer.lineNumber()));
        _doLoopLineNumberTagStack.push(tag);
    }

    /** A separate version of {@link #popCurrentLineNumber(String)} for the
     *  do-while-loop, which needs not only the line number of the "do"
     *  line, but also that of the "while" test.
     *  @param tag a String to use to verify that your pushes & pops haven't
     *  gotten out of sync.
     *  @return The line number off the stack that was previously stored there
     *  by {@link #pushCurrentLineNumber(String)}
     */
    protected Integer popDoLoopTestLineNumber(String tag) {
        String check = (String) _doLoopLineNumberTagStack.pop();
        if ((check == null && tag != null) || !check.equals(tag)) {
            _doLoopLineNumberStack.pop();
            yyerror("Internal grammar error: tag \"" + tag
                    + "\" does not equal check string on line-number stack (\""
                    + check + "\")");
            return new Integer(0);
        } else {
            return (Integer) _doLoopLineNumberStack.pop();
        }
    }

    /** Store _lexer.lineNumber for later retrieval after returning to the same
     *  level in the parse tree.
     *  @param tag a String to use to verify that your pushes & pops haven't
     *  gotten out of sync.
     */
    protected void pushBlockEndLineNumber(String tag) {
        _blockEndLineNumberStack.push(new Integer(_lexer.lineNumber()));
        _blockEndLineNumberTagStack.push(tag);
    }

    /** Pop a line number off the stack (as an Integer), previously stored there
     *  by {@link #pushBlockEndLineNumber(String)}.
     *  @param tag a String to use to verify that your pushes & pops haven't
     *  gotten out of sync.
     *  @return the line number off the stack.
     */
    protected Integer popBlockEndLineNumber(String tag) {
        String check = (String) _blockEndLineNumberTagStack.pop();
        if ((check == null && tag != null) || !check.equals(tag)) {
            _blockEndLineNumberStack.pop();
            yyerror("Internal grammar error: tag \""
                    + tag
                    + "\" does not equal check string on block-end line-number "
                    + "stack (\"" + check + "\")");
            return new Integer(0);
        } else {
            return (Integer) _blockEndLineNumberStack.pop();
        }
    }

    /** The key indicating the end of a block. */
    private static Integer _BLOCK_END_LINENUMBER_KEY = MetaModelStaticSemanticConstants.BLOCK_END_LINENUMBER_KEY;

    private static Integer _BLOCK_SECOND_LINENUMBER_KEY = MetaModelStaticSemanticConstants.BLOCK_SECOND_LINENUMBER_KEY;

    /** The key indicating a do loop test. */
    private static Integer _DOLOOP_TEST_LINENUMBER_KEY = MetaModelStaticSemanticConstants.DOLOOP_TEST_LINENUMBER_KEY;

    /** The key indicating a line number. */
    private static Integer _LINENUMBER_KEY = MetaModelStaticSemanticConstants.LINENUMBER_KEY;

    /** Used to detect whether we are inside a LTL formula or not. */
    private boolean _inLTLFormula = false;

    /** Used to detect whether we are inside an action formula or not. */
    private boolean _inActionFormula = false;

    /** Used to detect whether we are inside a netlist or not. */
    private boolean _inNetlist = false;

    /** Used to detect whether we are inside a constraint block or not. */
    private boolean _inConstraint = false;

    /** Used to detect whether we are inside a annotation block or not. */
    private boolean _inAnnotation = false;

    /** Used to detect whether we are inside a top level class or not. */
    private boolean _inClass = false;

    /** Used to detect whether there are nested expression labels. */
    private int _inExprLabel = 0;

    /** Used to detect whether we are inside a method or not. */
    private boolean _inMethod = false;

    /** Used to detect line number information */
    //private int _inLineNumber = 0;
    private int _inLineNumber1 = 0;

    private Stack _lineNumberStack = new Stack();

    private Stack _lineNumberTagStack = new Stack();

    private Stack _blockEndLineNumberStack = new Stack();

    private Stack _blockEndLineNumberTagStack = new Stack();

    private Stack _doLoopLineNumberStack = new Stack();

    private Stack _doLoopLineNumberTagStack = new Stack();

    /** Used to detect whether we are inside a Node declaration or not. */
    /** Node type includes Process, Medium, StateMedium, Scheduler and Netlist. */
    /** _nestLevel=1: in a top level declaration */
    /** _nestLevel>1: in an inner class declaration */
    private int _nestLevel = 0;

    /** Place to put the finished Abstract Syntax Tree (AST). */
    protected CompileUnitNode _theAST;

    /** Number of syntactic erros in the AST. */
    protected int _numErrors;

    /** Return the Abstract Syntax Tree (AST).
     *  @return the AST
     */
    public CompileUnitNode getAST() {
        return _theAST;
    }

    /** Handle an error message by incrementing the error count and printing
     *  a message to stdout.
     *  @param msg The error message to print.
     */
    protected void yyerror(String msg) {
        _numErrors++;
        String errMsg = _filename;
        String line = "";
        if (_lexer != null) {
            line = ":" + _lexer.lineNumber();
        }
        System.out.println(errMsg + line + ": " + msg);
    }

    /** The filename to parse. */
    protected String _filename = null;

    /** The lexer to use. */
    protected Lexer _lexer = null;

    //#line 5435 "MetaModelParser.java"
    //###############################################################
    // method: yylexdebug : check lexer state
    //###############################################################
    void yylexdebug(int state, int ch) {
        String s = null;
        if (ch < 0)
            ch = 0;
        if (ch <= YYMAXTOKEN) //check index bounds
            s = yyname[ch]; //now get it
        if (s == null)
            s = "illegal-symbol";
        debug("state " + state + ", reading " + ch + " (" + s + ")");
    }

    //###############################################################
    // method: yyparse : parse input and execute indicated items
    //###############################################################
    int yyparse() {
        int yyn; //next next thing to do
        int yym; //
        int yystate; //current parsing state from state table
        String yys; //current token string
        boolean doaction;
        init_stacks();
        yynerrs = 0;
        yyerrflag = 0;
        yychar = -1; //impossible char forces a read
        yystate = 0; //initial state
        state_push(yystate); //save it
        String yyrule[] = null;
        if (yydebug)
            yyrule = read_string_table("yyrule.tbl", NRULES - 2);
        while (true) //until parsing is done, either correctly, or w/error
        {
            doaction = true;
            if (yydebug)
                debug("loop");
            //#### NEXT ACTION (from reduction table)
            for (yyn = yydefred[yystate]; yyn == 0; yyn = yydefred[yystate]) {
                if (yydebug)
                    debug("yyn:" + yyn + "  state:" + yystate + "  char:"
                            + yychar);
                if (yychar < 0) //we want a char?
                {
                    yychar = yylex(); //get next token
                    //#### ERROR CHECK ####
                    if (yychar < 0) //it it didn't work/error
                    {
                        yychar = 0; //change it to default string (no -1!)
                        if (yydebug)
                            yylexdebug(yystate, yychar);
                    }
                }//yychar<0
                yyn = yysindex[yystate]; //get amount to shift by (shift index)
                if ((yyn != 0) && (yyn += yychar) >= 0 && yyn <= YYTABLESIZE
                        && yycheck[yyn] == yychar) {
                    if (yydebug)
                        debug("state " + yystate + ", shifting to state "
                                + yytable[yyn] + "");
                    //#### NEXT STATE ####
                    yystate = yytable[yyn];//we are in a new state
                    state_push(yystate); //save it
                    val_push(yylval); //push our lval as the input for next rule
                    yychar = -1; //since we have 'eaten' a token, say we need another
                    if (yyerrflag > 0) //have we recovered an error?
                        --yyerrflag; //give ourselves credit
                    doaction = false; //but don't process yet
                    break; //quit the yyn=0 loop
                }

                yyn = yyrindex[yystate]; //reduce
                if ((yyn != 0) && (yyn += yychar) >= 0 && yyn <= YYTABLESIZE
                        && yycheck[yyn] == yychar) { //we reduced!
                    if (yydebug)
                        debug("reduce");
                    yyn = yytable[yyn];
                    doaction = true; //get ready to execute
                    break; //drop down to actions
                } else //ERROR RECOVERY
                {
                    if (yyerrflag == 0) {
                        yyerror("syntax error");
                        yynerrs++;
                    }
                    if (yyerrflag < 3) //low error count?
                    {
                        yyerrflag = 3;
                        while (true) //do until break
                        {
                            if (stateptr < 0) //check for under & overflow here
                            {
                                yyerror("stack underflow. aborting..."); //note lower case 's'
                                return 1;
                            }
                            yyn = yysindex[state_peek(0)];
                            if ((yyn != 0) && (yyn += YYERRCODE) >= 0
                                    && yyn <= YYTABLESIZE
                                    && yycheck[yyn] == YYERRCODE) {
                                if (yydebug)
                                    debug("state "
                                            + state_peek(0)
                                            + ", error recovery shifting to state "
                                            + yytable[yyn] + " ");
                                yystate = yytable[yyn];
                                state_push(yystate);
                                val_push(yylval);
                                doaction = false;
                                break;
                            } else {
                                if (yydebug)
                                    debug("error recovery discarding state "
                                            + state_peek(0) + " ");
                                if (stateptr < 0) //check for under & overflow here
                                {
                                    yyerror("Stack underflow. aborting..."); //capital 'S'
                                    return 1;
                                }
                                state_pop();
                                val_pop();
                            }
                        }
                    } else //discard this token
                    {
                        if (yychar == 0)
                            return 1; //yyabort
                        if (yydebug) {
                            yys = null;
                            if (yychar <= YYMAXTOKEN)
                                yys = yyname[yychar];
                            if (yys == null)
                                yys = "illegal-symbol";
                            debug("state " + yystate
                                    + ", error recovery discards token "
                                    + yychar + " (" + yys + ")");
                        }
                        yychar = -1; //read another
                    }
                }//end error recovery
            }//yyn=0 loop
            if (!doaction) //any reason not to proceed?
                continue; //skip action
            yym = yylen[yyn]; //get count of terminals on rhs
            if (yydebug)
                if (yyrule == null) {
                    debug("state "
                            + yystate
                            + ", reducing "
                            + yym
                            + " by rule "
                            + yyn
                            + " yyrule is null, perhaps yyrule.tbl was not read in?");
                } else {
                    debug("state " + yystate + ", reducing " + yym
                            + " by rule " + yyn + " (" + yyrule[yyn] + ")");
                }
            if (yym > 0) { //if count of rhs not 'nil'
                try {
                    yyval = (MetaModelParserval) val_peek(yym - 1).clone(); //get current semantic value
                } catch (CloneNotSupportedException e) {
                    yyerror("Clone not supported");
                }
            } else {
                yyval = new MetaModelParserval();
            }
            switch (yyn) {
            //########## USER-SUPPLIED ACTIONS ##########
            case 1:
                //#line 331 "Grammar.y"
            {
                _theAST = (CompileUnitNode) val_peek(0).obj;
            }
                break;
            case 3:
                //#line 345 "Grammar.y"
            {
                yyval.obj = new IntLitNode(val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 4:
                //#line 350 "Grammar.y"
            {
                yyval.obj = new LongLitNode(val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 5:
                //#line 355 "Grammar.y"
            {
                yyval.obj = new FloatLitNode(val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 6:
                //#line 360 "Grammar.y"
            {
                yyval.obj = new DoubleLitNode(val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 7:
                //#line 365 "Grammar.y"
            {
                yyval.obj = new BoolLitNode("true");
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 8:
                //#line 370 "Grammar.y"
            {
                yyval.obj = new BoolLitNode("false");
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 9:
                //#line 375 "Grammar.y"
            {
                yyval.obj = new CharLitNode(val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 10:
                //#line 380 "Grammar.y"
            {
                yyval.obj = new StringLitNode(val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 11:
                //#line 385 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 12:
                //#line 390 "Grammar.y"
            {
                yyval.obj = new SpecialLitNode("LAST");
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 13:
                //#line 395 "Grammar.y"
            {
                yyval.obj = new SpecialLitNode("retval");
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 14:
                //#line 403 "Grammar.y"
            {
                pushCurrentLineNumber("Blackbox");
            }
                break;
            case 15:
                //#line 405 "Grammar.y"
            {
                yyval.obj = new BlackboxNode(val_peek(2).sval, val_peek(0).sval);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("Blackbox"));
            }
                break;
            case 21:
                //#line 428 "Grammar.y"
            {
                yyval.obj = BoolTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 22:
                //#line 433 "Grammar.y"
            {
                yyval.obj = CharTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 23:
                //#line 438 "Grammar.y"
            {
                yyval.obj = ByteTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 24:
                //#line 443 "Grammar.y"
            {
                yyval.obj = ShortTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 25:
                //#line 448 "Grammar.y"
            {
                yyval.obj = IntTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 26:
                //#line 453 "Grammar.y"
            {
                yyval.obj = FloatTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 27:
                //#line 458 "Grammar.y"
            {
                yyval.obj = LongTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 28:
                //#line 463 "Grammar.y"
            {
                yyval.obj = DoubleTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 29:
                //#line 468 "Grammar.y"
            {
                yyval.obj = EventTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 30:
                //#line 478 "Grammar.y"
            {
                yyval.obj = new TypeNameNode((NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 31:
                //#line 488 "Grammar.y"
            {
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        "metamodel", AbsentTreeNode.instance);
                name = new NameNode(name, "lang", AbsentTreeNode.instance);
                name = new NameNode(name, "Medium", AbsentTreeNode.instance);
                yyval.obj = new TypeNameNode((NameNode) name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 32:
                //#line 497 "Grammar.y"
            {
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        "metamodel", AbsentTreeNode.instance);
                name = new NameNode(name, "lang", AbsentTreeNode.instance);
                name = new NameNode(name, "Netlist", AbsentTreeNode.instance);
                yyval.obj = new TypeNameNode((NameNode) name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 33:
                //#line 506 "Grammar.y"
            {
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        "metamodel", AbsentTreeNode.instance);
                name = new NameNode(name, "lang", AbsentTreeNode.instance);
                name = new NameNode(name, "Process", AbsentTreeNode.instance);
                yyval.obj = new TypeNameNode((NameNode) name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 34:
                //#line 515 "Grammar.y"
            {
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        "metamodel", AbsentTreeNode.instance);
                name = new NameNode(name, "lang", AbsentTreeNode.instance);
                name = new NameNode(name, "Scheduler", AbsentTreeNode.instance);
                yyval.obj = new TypeNameNode((NameNode) name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 35:
                //#line 524 "Grammar.y"
            {
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        "metamodel", AbsentTreeNode.instance);
                name = new NameNode(name, "lang", AbsentTreeNode.instance);
                name = new NameNode(name, "StateMedium",
                        AbsentTreeNode.instance);
                yyval.obj = new TypeNameNode((NameNode) name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 36:
                //#line 533 "Grammar.y"
            {
                yyval.obj = PCTypeNode.instance;
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 37:
                //#line 543 "Grammar.y"
            {
                yyval.obj = new ArrayTypeNode((TypeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 38:
                //#line 554 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 39:
                //#line 556 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 40:
                //#line 561 "Grammar.y"
            {
                yyval.obj = new NameNode(AbsentTreeNode.instance,
                        val_peek(0).sval, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 41:
                //#line 570 "Grammar.y"
            {
                yyval.obj = new NameNode((NameNode) val_peek(2).obj,
                        val_peek(0).sval, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 42:
                //#line 578 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 43:
                //#line 580 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 44:
                //#line 585 "Grammar.y"
            {
                yyval.obj = new NameNode(AbsentTreeNode.instance,
                        val_peek(0).sval, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 45:
                //#line 590 "Grammar.y"
            {
                yyval.obj = new NameNode(AbsentTreeNode.instance,
                        val_peek(3).sval, new TemplateParametersNode(
                                (List) val_peek(1).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 46:
                //#line 599 "Grammar.y"
            {
                yyval.obj = new NameNode((NameNode) val_peek(2).obj,
                        val_peek(0).sval, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 47:
                //#line 604 "Grammar.y"
            {
                yyval.obj = new NameNode((NameNode) val_peek(5).obj,
                        val_peek(3).sval, new TemplateParametersNode(
                                (List) val_peek(1).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 48:
                //#line 613 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 49:
                //#line 615 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 50:
                //#line 622 "Grammar.y"
            {
                yyval.obj = new CompileUnitNode((TreeNode) val_peek(2).obj,
                        (List) val_peek(1).obj, (List) val_peek(0).obj);
            }
                break;
            case 51:
                //#line 624 "Grammar.y"
            {
                yyerror("Confused by previous errors - halting.");
            }
                break;
            case 52:
                //#line 631 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 53:
                //#line 633 "Grammar.y"
            {
                yyerror("Incorrect package name in package declaration, after '"
                        + qualifiedName((NameNode) val_peek(3).obj) + "'.");
            }
                break;
            case 54:
                //#line 636 "Grammar.y"
            {
                yyerror("Missing semicolon (;) after package declaration.");
            }
                break;
            case 55:
                //#line 638 "Grammar.y"
            {
                yyerror("Missing package name in package declaration.");
            }
                break;
            case 56:
                //#line 640 "Grammar.y"
            {
                yyerror("Incorrect package name in package declaration.");
            }
                break;
            case 57:
                //#line 642 "Grammar.y"
            {
                yyval.obj = AbsentTreeNode.instance;
            }
                break;
            case 58:
                //#line 649 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 59:
                //#line 651 "Grammar.y"
            {
                yyval.obj = cons(val_peek(1).obj, (List) val_peek(0).obj);
            }
                break;
            case 60:
                //#line 653 "Grammar.y"
            {
                yyerror("Package name must be declared before import statements.");
            }
                break;
            case 63:
                //#line 660 "Grammar.y"
            {
                yyerror("Incorrect type name in import statement, after '"
                        + qualifiedName((NameNode) val_peek(2).obj) + "'.");
            }
                break;
            case 64:
                //#line 663 "Grammar.y"
            {
                yyerror("Incorrect type name in import statement.");
            }
                break;
            case 65:
                //#line 665 "Grammar.y"
            {
                yyerror("Missing type name in import statement.");
            }
                break;
            case 66:
                //#line 667 "Grammar.y"
            {
                yyerror("Missing semicolon (;) after import statement.");
            }
                break;
            case 67:
                //#line 669 "Grammar.y"
            {
                yyerror("Missing semicolon (;) after import statement.");
            }
                break;
            case 68:
                //#line 674 "Grammar.y"
            {
                yyval.obj = new ImportNode((NameNode) val_peek(1).obj);
            }
                break;
            case 69:
                //#line 679 "Grammar.y"
            {
                yyval.obj = new ImportOnDemandNode((NameNode) val_peek(3).obj);
            }
                break;
            case 70:
                //#line 687 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 71:
                //#line 689 "Grammar.y"
            {
                yyval.obj = cons(val_peek(1).obj, (List) val_peek(0).obj);
            }
                break;
            case 72:
                //#line 691 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 73:
                //#line 696 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 74:
                //#line 698 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 75:
                //#line 700 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 76:
                //#line 705 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 77:
                //#line 707 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 78:
                //#line 709 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 79:
                //#line 711 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 80:
                //#line 713 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 81:
                //#line 715 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 82:
                //#line 717 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 83:
                //#line 719 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 84:
                //#line 727 "Grammar.y"
            {
                UserTypeDeclNode decl = (UserTypeDeclNode) val_peek(0).obj;
                List params = (List) val_peek(2).obj;
                decl.setParTypeNames(params);
                yyval.obj = decl;
            }
                break;
            case 85:
                //#line 736 "Grammar.y"
            {
                UserTypeDeclNode decl = (UserTypeDeclNode) val_peek(0).obj;
                List params = (List) val_peek(2).obj;
                decl.setParTypeNames(params);
                yyval.obj = decl;
            }
                break;
            case 86:
                //#line 744 "Grammar.y"
            {
                UserTypeDeclNode decl = (UserTypeDeclNode) val_peek(0).obj;
                List params = (List) val_peek(2).obj;
                decl.setParTypeNames(params);
                yyval.obj = decl;
            }
                break;
            case 87:
                //#line 752 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 88:
                //#line 754 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 89:
                //#line 759 "Grammar.y"
            { /* FIXME: Use valid type list*/
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 90:
                //#line 762 "Grammar.y"
            { /* FIXME: Use valid type list*/
                yyval.obj = val_peek(2).obj;
            }
                break;
            case 91:
                //#line 768 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 92:
                //#line 770 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 93:
                //#line 781 "Grammar.y"
            {
                yyval.ival = val_peek(0).ival;
            }
                break;
            case 94:
                //#line 783 "Grammar.y"
            {
                yyval.ival = Modifier.NO_MOD;
            }
                break;
            case 95:
                //#line 788 "Grammar.y"
            {
                yyval.ival = val_peek(0).ival;
            }
                break;
            case 96:
                //#line 790 "Grammar.y"
            {
                yyval.ival = val_peek(1).ival | val_peek(0).ival;
            }
                break;
            case 97:
                //#line 795 "Grammar.y"
            {
                yyval.ival = Modifier.PUBLIC_MOD;
            }
                break;
            case 98:
                //#line 797 "Grammar.y"
            {
                yyval.ival = Modifier.PROTECTED_MOD;
            }
                break;
            case 99:
                //#line 799 "Grammar.y"
            {
                yyval.ival = Modifier.PRIVATE_MOD;
            }
                break;
            case 100:
                //#line 801 "Grammar.y"
            {
                yyval.ival = Modifier.ABSTRACT_MOD;
            }
                break;
            case 101:
                //#line 803 "Grammar.y"
            {
                yyval.ival = Modifier.FINAL_MOD;
            }
                break;
            case 102:
                //#line 805 "Grammar.y"
            {
                yyval.ival = Modifier.STATIC_MOD;
            }
                break;
            case 103:
                //#line 807 "Grammar.y"
            {
                yyval.ival = Modifier.ELABORATE_MOD;
            }
                break;
            case 104:
                //#line 814 "Grammar.y"
            {
                yyval.ival = Effect.CONSTANT_EFFECT;
            }
                break;
            case 105:
                //#line 816 "Grammar.y"
            {
                yyval.ival = Effect.EVAL_EFFECT;
            }
                break;
            case 106:
                //#line 818 "Grammar.y"
            {
                yyval.ival = Effect.UPDATE_EFFECT;
            }
                break;
            case 107:
                //#line 825 "Grammar.y"
            {
                yyval.obj = new DeclaratorNode(val_peek(0).ival,
                        (NameNode) val_peek(1).obj, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 108:
                //#line 833 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 109:
                //#line 835 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 110:
                //#line 840 "Grammar.y"
            {
                yyval.obj = new DeclaratorNode(val_peek(2).ival,
                        (NameNode) val_peek(3).obj, (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 111:
                //#line 848 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 112:
                //#line 850 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 113:
                //#line 855 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 114:
                //#line 857 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 115:
                //#line 862 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 116:
                //#line 864 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 117:
                //#line 873 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 118:
                //#line 875 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 119:
                //#line 877 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 120:
                //#line 879 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 121:
                //#line 886 "Grammar.y"
            {
                Modifier.checkFieldModifiers(val_peek(3).ival);
                List result = new LinkedList();
                List varDecls = (List) val_peek(1).obj;
                Iterator itr = varDecls.iterator();
                while (itr.hasNext()) {
                    DeclaratorNode decl = (DeclaratorNode) itr.next();
                    int dims = decl.getDims();
                    NameNode name = decl.getName();
                    TreeNode init = decl.getInitExpr();
                    TypeNode type = TypeUtility.makeArrayType(
                            (TypeNode) val_peek(2).obj, dims);
                    FieldDeclNode node = new FieldDeclNode(val_peek(3).ival,
                            type, name, init);
                    node.setProperty(_LINENUMBER_KEY, decl
                            .getProperty(_LINENUMBER_KEY));
                    result = cons(node, result);
                }
                yyval.obj = result;
            }
                break;
            case 122:
                //#line 907 "Grammar.y"
            {
                Modifier.checkConstantFieldModifiers(val_peek(3).ival);
                List result = new LinkedList();
                List varDecls = (List) val_peek(1).obj;
                Iterator itr = varDecls.iterator();
                while (itr.hasNext()) {
                    DeclaratorNode decl = (DeclaratorNode) itr.next();
                    int dims = decl.getDims();
                    NameNode name = decl.getName();
                    TreeNode init = decl.getInitExpr();
                    TypeNode type = TypeUtility.makeArrayType(
                            (TypeNode) val_peek(2).obj, dims);
                    FieldDeclNode node = new FieldDeclNode(val_peek(3).ival,
                            type, name, init);
                    node.setProperty(_LINENUMBER_KEY, decl
                            .getProperty(_LINENUMBER_KEY));
                    result = cons(node, result);
                }
                yyval.obj = result;
            }
                break;
            case 123:
                //#line 929 "Grammar.y"
            {
                yyval.obj = VoidTypeNode.instance;
            }
                break;
            case 124:
                //#line 934 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 125:
                //#line 936 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 126:
                //#line 941 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 127:
                //#line 943 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 128:
                //#line 948 "Grammar.y"
            {
                Modifier.checkFormalModifiers(val_peek(2).ival);
                DeclaratorNode decl = (DeclaratorNode) val_peek(0).obj;
                int dims = decl.getDims();
                NameNode name = decl.getName();
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(1).obj, dims);
                yyval.obj = new ParameterNode(val_peek(2).ival, type, name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 129:
                //#line 961 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 130:
                //#line 963 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 131:
                //#line 968 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 132:
                //#line 973 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 133:
                //#line 975 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 134:
                //#line 980 "Grammar.y"
            {
                Modifier.checkMethodSignatureModifiers(val_peek(8).ival);
                int modifier = val_peek(8).ival;
                int effect = val_peek(7).ival;
                int dims = val_peek(1).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(6).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(5).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(3).obj;
                TreeNode body = AbsentTreeNode.instance;
                List ports = new LinkedList();
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 135:
                //#line 995 "Grammar.y"
            {
                Modifier.checkMethodSignatureModifiers(val_peek(8).ival);
                int modifier = val_peek(8).ival;
                int effect = val_peek(7).ival;
                int dims = val_peek(1).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(6).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(5).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(3).obj;
                TreeNode body = AbsentTreeNode.instance;
                List ports = new LinkedList();
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 136:
                //#line 1010 "Grammar.y"
            {
                Modifier.checkMethodSignatureModifiers(val_peek(7).ival);
                int modifier = val_peek(7).ival;
                int effect = Effect.NO_EFFECT;
                int dims = val_peek(1).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(6).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(5).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(3).obj;
                TreeNode body = AbsentTreeNode.instance;
                List ports = new LinkedList();
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 137:
                //#line 1025 "Grammar.y"
            {
                Modifier.checkMethodSignatureModifiers(val_peek(7).ival);
                int modifier = val_peek(7).ival;
                int effect = Effect.NO_EFFECT;
                int dims = val_peek(1).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(6).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(5).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(3).obj;
                TreeNode body = AbsentTreeNode.instance;
                List ports = new LinkedList();
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 138:
                //#line 1043 "Grammar.y"
            {
                pushCurrentLineNumber("JavaMethodDeclaration");
                _inMethod = true;
            }
                break;
            case 139:
                //#line 1044 "Grammar.y"
            {
                _inMethod = false;
            }
                break;
            case 140:
                //#line 1045 "Grammar.y"
            {
                Modifier.checkMethodModifiers(val_peek(9).ival);
                int modifier = val_peek(9).ival;
                int effect = Effect.NO_EFFECT;
                int dims = val_peek(3).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(8).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(7).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(5).obj;
                TreeNode body = (TreeNode) val_peek(1).obj;
                List ports = new LinkedList();
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("JavaMethodDeclaration"));
            }
                break;
            case 141:
                //#line 1060 "Grammar.y"
            {
                pushCurrentLineNumber("JavaMethodDeclaration");
                _inMethod = true;
            }
                break;
            case 142:
                //#line 1061 "Grammar.y"
            {
                _inMethod = false;
            }
                break;
            case 143:
                //#line 1062 "Grammar.y"
            {
                Modifier.checkMethodModifiers(val_peek(9).ival);
                int modifier = val_peek(9).ival;
                int effect = Effect.NO_EFFECT;
                int dims = val_peek(3).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(8).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(7).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(5).obj;
                TreeNode body = (TreeNode) val_peek(1).obj;
                List ports = new LinkedList();
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("JavaMethodDeclaration"));
            }
                break;
            case 144:
                //#line 1081 "Grammar.y"
            {
                pushCurrentLineNumber("InterfaceMethodDeclaration");
                _inMethod = true;
            }
                break;
            case 145:
                //#line 1082 "Grammar.y"
            {
                _inMethod = false;
            }
                break;
            case 146:
                //#line 1083 "Grammar.y"
            {
                Modifier.checkInterfaceMethodModifiers(val_peek(11).ival);
                int modifier = val_peek(11).ival;
                int effect = val_peek(10).ival;
                int dims = val_peek(4).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(9).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(8).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(6).obj;
                TreeNode body = (TreeNode) val_peek(1).obj;
                List ports = (List) val_peek(3).obj;
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("InterfaceMethodDeclaration"));
            }
                break;
            case 147:
                //#line 1099 "Grammar.y"
            {
                pushCurrentLineNumber("InterfaceMethodDeclaration");
                _inMethod = true;
            }
                break;
            case 148:
                //#line 1100 "Grammar.y"
            {
                _inMethod = false;
            }
                break;
            case 149:
                //#line 1101 "Grammar.y"
            {
                Modifier.checkInterfaceMethodModifiers(val_peek(11).ival);
                int modifier = val_peek(11).ival;
                int effect = val_peek(10).ival;
                int dims = val_peek(4).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(9).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(8).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(6).obj;
                TreeNode body = (TreeNode) val_peek(1).obj;
                List ports = (List) val_peek(3).obj;
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("InterfaceMethodDeclaration"));
            }
                break;
            case 150:
                //#line 1119 "Grammar.y"
            {
                pushCurrentLineNumber("NonInterfaceMethodDeclaration");
                _inMethod = true;
            }
                break;
            case 151:
                //#line 1120 "Grammar.y"
            {
                _inMethod = false;
            }
                break;
            case 152:
                //#line 1121 "Grammar.y"
            {
                Modifier.checkMethodModifiers(val_peek(10).ival);
                int modifier = val_peek(10).ival;
                int effect = Effect.NO_EFFECT;
                int dims = val_peek(4).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(9).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(8).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(6).obj;
                TreeNode body = (TreeNode) val_peek(1).obj;
                List ports = (List) val_peek(3).obj;
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("NonInterfaceMethodDeclaration"));
            }
                break;
            case 153:
                //#line 1136 "Grammar.y"
            {
                pushCurrentLineNumber("NonInterfaceMethodDeclaration");
                _inMethod = true;
            }
                break;
            case 154:
                //#line 1137 "Grammar.y"
            {
                _inMethod = false;
            }
                break;
            case 155:
                //#line 1138 "Grammar.y"
            {
                Modifier.checkMethodModifiers(val_peek(10).ival);
                int modifier = val_peek(10).ival;
                int effect = Effect.NO_EFFECT;
                int dims = val_peek(4).ival;
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(9).obj, dims);
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(8).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(6).obj;
                TreeNode body = (TreeNode) val_peek(1).obj;
                List ports = (List) val_peek(3).obj;
                yyval.obj = new MethodDeclNode(modifier, name, params, body,
                        type, effect, ports);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("NonInterfaceMethodDeclaration"));
            }
                break;
            case 156:
                //#line 1156 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 157:
                //#line 1158 "Grammar.y"
            {
                yyval.obj = AbsentTreeNode.instance;
            }
                break;
            case 158:
                //#line 1167 "Grammar.y"
            {
                _inMethod = false;
                Modifier.checkConstructorModifiers(val_peek(9).ival);
                int modifier = val_peek(9).ival;
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(8).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(6).obj;
                if (!_inClass && _nestLevel == 1) {
                    if (params.size() == 0) {
                        yyerror("A name (String) must be provided to constructor "
                                + val_peek(8).sval
                                + ", and it must be the first argument of the constructor.");
                    }
                    ParameterNode prmnode = (ParameterNode) params.get(0);
                    if (!(prmnode.getDefType() instanceof TypeNameNode)) {
                        yyerror("A name (String) must be provided to constructor "
                                + val_peek(8).sval
                                + ", and it must be the first argument of the constructor.");
                    }
                    TypeNameNode tnnode = (TypeNameNode) prmnode.getDefType();
                    if (!tnnode.getName().getIdent().equals("String")) {
                        yyerror("A name (String) must be provided to constructor "
                                + val_peek(8).sval
                                + ", and it must be the first argument of the constructor.");
                    }
                }
                BlockNode block = new BlockNode((List) val_peek(1).obj);
                ConstructorCallNode call = (ConstructorCallNode) val_peek(2).obj;
                yyval.obj = new ConstructorDeclNode(modifier, name, params,
                        block, call);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstructorDeclaration"));
            }
                break;
            case 159:
                //#line 1200 "Grammar.y"
            {
                _inMethod = false;
                Modifier.checkConstructorModifiers(val_peek(8).ival);
                int modifier = val_peek(8).ival;
                NameNode name = new NameNode(AbsentTreeNode.instance,
                        val_peek(7).sval, AbsentTreeNode.instance);
                List params = (List) val_peek(5).obj;
                if (!_inClass && _nestLevel == 1) {
                    if (params.size() == 0)
                        yyerror("A name (String) must be provided to constructor "
                                + val_peek(7).sval
                                + ", and it must be the first argument of the constructor.");
                    ParameterNode prmnode = (ParameterNode) params.get(0);
                    if (!(prmnode.getDefType() instanceof TypeNameNode))
                        yyerror("A name (String) must be provided to constructor "
                                + val_peek(7).sval
                                + ", and it must be the first argument of the constructor.");
                    TypeNameNode tnnode = (TypeNameNode) prmnode.getDefType();
                    if (!tnnode.getName().getIdent().equals("String"))
                        yyerror("A name (String) must be provided to constructor "
                                + val_peek(7).sval
                                + ", and it must be the first argument of the constructor.");
                }
                BlockNode block = new BlockNode((List) val_peek(1).obj);
                LinkedList par = new LinkedList();
                if (!_inClass && _nestLevel == 1
                        && ((List) val_peek(5).obj).size() > 0) {
                    ParameterNode param = (ParameterNode) ((List) val_peek(5).obj)
                            .get(0);
                    try {
                        par.add(new ObjectNode((NameNode) param.getName()
                                .clone()));
                    } catch (CloneNotSupportedException ex) {
                        throw new RuntimeException("Clone of '"
                                + (NameNode) param.getName()
                                + "' not supported.", ex);
                    }
                }
                ConstructorCallNode call = new SuperConstructorCallNode(par);
                yyval.obj = new ConstructorDeclNode(modifier, name, params,
                        block, call);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstructorDeclaration"));
            }
                break;
            case 160:
                //#line 1243 "Grammar.y"
            {
                pushCurrentLineNumber("ConstructorDeclaration");
                _inMethod = true;
            }
                break;
            case 161:
                //#line 1254 "Grammar.y"
            {
                yyval.obj = new ThisConstructorCallNode((List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 162:
                //#line 1259 "Grammar.y"
            {
                yyval.obj = new SuperConstructorCallNode((List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 163:
                //#line 1269 "Grammar.y"
            {
                Modifier.checkParameterModifiers(val_peek(3).ival);
                List result = new LinkedList();
                List varDecls = (List) val_peek(1).obj;
                Iterator itr = varDecls.iterator();
                while (itr.hasNext()) {
                    DeclaratorNode decl = (DeclaratorNode) itr.next();
                    int dims = decl.getDims();
                    NameNode name = decl.getName();
                    TypeNode type = TypeUtility.makeArrayType(
                            (TypeNode) val_peek(2).obj, dims);
                    ParameterDeclNode node = new ParameterDeclNode(
                            val_peek(3).ival, type, name);
                    result = cons(node, result);
                }
                yyval.obj = result;
            }
                break;
            case 164:
                //#line 1289 "Grammar.y"
            {
                Modifier.checkPortModifiers(val_peek(3).ival);
                List result = new LinkedList();
                List varDecls = (List) val_peek(1).obj;
                Iterator itr = varDecls.iterator();
                while (itr.hasNext()) {
                    DeclaratorNode decl = (DeclaratorNode) itr.next();
                    int dims = decl.getDims();
                    NameNode name = decl.getName();
                    TypeNode type = TypeUtility.makeArrayType(
                            (TypeNode) val_peek(2).obj, dims);
                    PortDeclNode node = new PortDeclNode(val_peek(3).ival,
                            type, name);
                    result = cons(node, result);
                }
                yyval.obj = result;
            }
                break;
            case 165:
                //#line 1310 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 166:
                //#line 1312 "Grammar.y"
            { /* This will be fixed later by class resolution*/
                yyval.obj = AbsentTreeNode.instance;
            }
                break;
            case 167:
                //#line 1318 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 168:
                //#line 1320 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 169:
                //#line 1325 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 170:
                //#line 1327 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 171:
                //#line 1332 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 172:
                //#line 1334 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 173:
                //#line 1342 "Grammar.y"
            {
                pushCurrentLineNumber("InterfaceDeclaration");
                _nestLevel++;
            }
                break;
            case 174:
                //#line 1344 "Grammar.y"
            {
                _nestLevel--;
                Modifier.checkInterfaceModifiers(val_peek(5).ival);
                yyval.obj = new InterfaceDeclNode(val_peek(5).ival,
                        (NameNode) val_peek(3).obj, (List) val_peek(2).obj,
                        (List) val_peek(0).obj, new LinkedList());
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("InterfaceDeclaration"));
            }
                break;
            case 175:
                //#line 1355 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 176:
                //#line 1360 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 177:
                //#line 1362 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 178:
                //#line 1367 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 179:
                //#line 1369 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 180:
                //#line 1371 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 181:
                //#line 1379 "Grammar.y"
            {
                pushCurrentLineNumber("QuantityDeclaration");
                if (_nestLevel == 0)
                    _inClass = true;
                _nestLevel++;
            }
                break;
            case 182:
                //#line 1383 "Grammar.y"
            {
                _nestLevel--;
                if (_nestLevel == 0)
                    _inClass = false;
                Modifier.checkClassModifiers(val_peek(6).ival);
                int modifier = val_peek(6).ival;
                NameNode name = (NameNode) val_peek(4).obj;
                TreeNode sup = (TreeNode) val_peek(3).obj;
                List ifnames = (List) val_peek(2).obj;
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, !_inClass && _nestLevel == 0);
                yyval.obj = new QuantityDeclNode(modifier, name, ifnames,
                        members, pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("QuantityDeclaration"));
            }
                break;
            case 183:
                //#line 1401 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 184:
                //#line 1406 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 185:
                //#line 1408 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 186:
                //#line 1413 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 187:
                //#line 1415 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 188:
                //#line 1417 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 189:
                //#line 1419 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 190:
                //#line 1421 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 191:
                //#line 1423 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 192:
                //#line 1425 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 193:
                //#line 1427 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 194:
                //#line 1429 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 195:
                //#line 1437 "Grammar.y"
            {
                pushCurrentLineNumber("ClassDeclaration");
                if (_nestLevel == 0)
                    _inClass = true;
                _nestLevel++;
            }
                break;
            case 196:
                //#line 1442 "Grammar.y"
            {
                _nestLevel--;
                if (_nestLevel == 0)
                    _inClass = false;
                Modifier.checkClassModifiers(val_peek(6).ival);
                int modifier = val_peek(6).ival;
                NameNode name = (NameNode) val_peek(4).obj;
                TreeNode sup = (TreeNode) val_peek(3).obj;
                List ifnames = (List) val_peek(2).obj;
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, false);
                yyval.obj = new ClassDeclNode(modifier, name, ifnames, members,
                        pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ClassDeclaration"));
            }
                break;
            case 197:
                //#line 1460 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 198:
                //#line 1465 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 199:
                //#line 1467 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 200:
                //#line 1472 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 201:
                //#line 1474 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 202:
                //#line 1476 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 203:
                //#line 1478 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 204:
                //#line 1480 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 205:
                //#line 1482 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 206:
                //#line 1490 "Grammar.y"
            {
                pushCurrentLineNumber("ProcessDeclaration");
                _nestLevel++;
            }
                break;
            case 207:
                //#line 1492 "Grammar.y"
            {
                _nestLevel--;
                Modifier.checkProcessModifiers(val_peek(5).ival);
                int modifier = val_peek(5).ival;
                NameNode name = (NameNode) val_peek(3).obj;

                TreeNode sup = (TreeNode) val_peek(2).obj;
                List ifnames = new LinkedList();
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, !_inClass && _nestLevel == 0);
                yyval.obj = new ProcessDeclNode(modifier, name, ifnames,
                        members, pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ProcessDeclaration"));
            }
                break;
            case 208:
                //#line 1510 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 209:
                //#line 1515 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 210:
                //#line 1517 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 211:
                //#line 1522 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 212:
                //#line 1524 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 213:
                //#line 1526 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 214:
                //#line 1528 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 215:
                //#line 1530 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 216:
                //#line 1532 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 217:
                //#line 1534 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 218:
                //#line 1536 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 219:
                //#line 1538 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 220:
                //#line 1546 "Grammar.y"
            {
                pushCurrentLineNumber("MediumDeclaration");
                _nestLevel++;
            }
                break;
            case 221:
                //#line 1548 "Grammar.y"
            {
                _nestLevel--;
                Modifier.checkMediumModifiers(val_peek(6).ival);
                int modifier = val_peek(6).ival;
                NameNode name = (NameNode) val_peek(4).obj;
                TreeNode sup = (TreeNode) val_peek(3).obj;
                List ifnames = (List) val_peek(2).obj;
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, !_inClass && _nestLevel == 0);
                yyval.obj = new MediumDeclNode(modifier, name, ifnames,
                        members, pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("MediumDeclaration"));
            }
                break;
            case 222:
                //#line 1565 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 223:
                //#line 1570 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 224:
                //#line 1572 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 225:
                //#line 1577 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 226:
                //#line 1579 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 227:
                //#line 1581 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 228:
                //#line 1583 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 229:
                //#line 1585 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 230:
                //#line 1587 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 231:
                //#line 1589 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 232:
                //#line 1591 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 233:
                //#line 1593 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 234:
                //#line 1601 "Grammar.y"
            {
                pushCurrentLineNumber("SchedulerDeclaration");
                _nestLevel++;
            }
                break;
            case 235:
                //#line 1603 "Grammar.y"
            {
                _nestLevel--;
                Modifier.checkSchedulerModifiers(val_peek(6).ival);
                int modifier = val_peek(6).ival;
                NameNode name = (NameNode) val_peek(4).obj;
                TreeNode sup = (TreeNode) val_peek(3).obj;
                List ifnames = (List) val_peek(2).obj;
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, !_inClass && _nestLevel == 0);
                yyval.obj = new SchedulerDeclNode(modifier, name, ifnames,
                        members, pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("SchedulerDeclaration"));
            }
                break;
            case 236:
                //#line 1620 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 237:
                //#line 1625 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 238:
                //#line 1627 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 239:
                //#line 1632 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 240:
                //#line 1634 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 241:
                //#line 1636 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 242:
                //#line 1638 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 243:
                //#line 1640 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 244:
                //#line 1642 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 245:
                //#line 1644 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 246:
                //#line 1646 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 247:
                //#line 1648 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 248:
                //#line 1656 "Grammar.y"
            {
                pushCurrentLineNumber("StateMediumDeclaration");
                _nestLevel++;
            }
                break;
            case 249:
                //#line 1658 "Grammar.y"
            {
                _nestLevel--;
                Modifier.checkSMModifiers(val_peek(6).ival);
                int modifier = val_peek(6).ival;
                NameNode name = (NameNode) val_peek(4).obj;
                TreeNode sup = (TreeNode) val_peek(3).obj;
                List ifnames = (List) val_peek(2).obj;
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, !_inClass && _nestLevel == 0);
                yyval.obj = new SMDeclNode(modifier, name, ifnames, members,
                        pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("StateMediumDeclaration"));
            }
                break;
            case 250:
                //#line 1675 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 251:
                //#line 1680 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 252:
                //#line 1682 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 253:
                //#line 1687 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 254:
                //#line 1689 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 255:
                //#line 1691 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 256:
                //#line 1693 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 257:
                //#line 1695 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 258:
                //#line 1697 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 259:
                //#line 1699 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 260:
                //#line 1701 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 261:
                //#line 1708 "Grammar.y"
            {
                pushCurrentLineNumber("NetListDeclaration");
                _inNetlist = true;
                _nestLevel++;
            }
                break;
            case 262:
                //#line 1712 "Grammar.y"
            {
                _nestLevel--;
                _inNetlist = false;
                Modifier.checkNetlistModifiers(val_peek(6).ival);
                int modifier = val_peek(6).ival;
                NameNode name = (NameNode) val_peek(4).obj;
                TreeNode sup = (TreeNode) val_peek(3).obj;
                List ifnames = (List) val_peek(2).obj;
                List members = (List) val_peek(0).obj;
                List pars = new LinkedList();
                forceOneConstructor(name, members, !_inClass && _nestLevel == 0);
                yyval.obj = new NetlistDeclNode(modifier, name, ifnames,
                        members, pars, sup);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("NetListDeclaration"));
            }
                break;
            case 263:
                //#line 1730 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 264:
                //#line 1735 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 265:
                //#line 1737 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 266:
                //#line 1742 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 267:
                //#line 1744 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 268:
                //#line 1746 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 269:
                //#line 1748 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 270:
                //#line 1750 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 271:
                //#line 1752 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 272:
                //#line 1754 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 273:
                //#line 1761 "Grammar.y"
            {
                yyval.obj = new ArrayInitNode((List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 274:
                //#line 1765 "Grammar.y"
            {
                yyval.obj = new ArrayInitNode((List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 275:
                //#line 1769 "Grammar.y"
            {
                yyval.obj = new ArrayInitNode(new LinkedList());
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 276:
                //#line 1777 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 277:
                //#line 1779 "Grammar.y"
            {
                yyval.obj = append((List) val_peek(2).obj, val_peek(0).obj);
            }
                break;
            case 278:
                //#line 1784 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 279:
                //#line 1786 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 280:
                //#line 1795 "Grammar.y"
            {
                pushBlockEndLineNumber("Block");
            }
                break;
            case 281:
                //#line 1796 "Grammar.y"
            {
                yyval.obj = new BlockNode((List) val_peek(2).obj);
                /*
                 * ((TreeNode)$$).setProperty(
                 *           _LINENUMBER_KEY,
                 *           popCurrentLineNumber("Block"));
                 */
                List statements = (List) val_peek(2).obj;
                /* The LINENUMBER of a block is that of its first non-empty statement,*/
                /* or else null if it has no non-empty statement.*/
                Integer myLineNumber = null;
                Integer secondLineNumber = null;
                if (statements != null && !statements.isEmpty()) {
                    for (int i = 0; i < statements.size(); i++) {
                        TreeNode stmt = (TreeNode) statements.get(i);
                        if (stmt instanceof EmptyStmtNode) {
                            continue;
                        }
                        Object lineNumberObj = stmt
                                .getProperty(_LINENUMBER_KEY);
                        if (myLineNumber == null) {
                            if (lineNumberObj instanceof Integer) {
                                myLineNumber = (Integer) lineNumberObj;
                            }
                        } else {
                            /* Block's line number is set.  Now set the*/
                            /* 2nd-statement-line number.*/
                            if (lineNumberObj instanceof Integer
                                    && ((Integer) lineNumberObj).intValue() > myLineNumber
                                            .intValue()) {
                                secondLineNumber = (Integer) lineNumberObj;
                                break;
                            }
                        }
                    }
                }
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        myLineNumber);
                ((TreeNode) yyval.obj).setProperty(_BLOCK_END_LINENUMBER_KEY,
                        popBlockEndLineNumber("Block"));
                if (secondLineNumber != null) {
                    ((TreeNode) yyval.obj).setProperty(
                            _BLOCK_SECOND_LINENUMBER_KEY, secondLineNumber);
                }
            }
                break;
            case 282:
                //#line 1847 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 283:
                //#line 1849 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 284:
                //#line 1854 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 285:
                //#line 1856 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 286:
                //#line 1861 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 287:
                //#line 1863 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 288:
                //#line 1870 "Grammar.y"
            {
                pushCurrentLineNumber("LocalVariableDeclarationStatement");
            }
                break;
            case 289:
                //#line 1872 "Grammar.y"
            {
                Modifier.checkLocalVarModifiers(val_peek(4).ival);
                List result = new LinkedList();
                List varDecls = (List) val_peek(1).obj;
                Integer myLineNumber = popCurrentLineNumber("LocalVariableDeclarationStatement");
                Iterator itr = varDecls.iterator();
                while (itr.hasNext()) {
                    DeclaratorNode decl = (DeclaratorNode) itr.next();
                    int dims = decl.getDims();
                    NameNode name = decl.getName();
                    TreeNode init = decl.getInitExpr();
                    TypeNode type = TypeUtility.makeArrayType(
                            (TypeNode) val_peek(3).obj, dims);
                    LocalVarDeclNode node = new LocalVarDeclNode(
                            val_peek(4).ival, type, name, init);
                    node.setProperty(_LINENUMBER_KEY, myLineNumber);
                    result = cons(node, result);
                }
                yyval.obj = result;
            }
                break;
            case 290:
                //#line 1890 "Grammar.y"
            {
                pushCurrentLineNumber("LocalVariableDeclarationStatement");
            }
                break;
            case 291:
                //#line 1892 "Grammar.y"
            {
                List result = new LinkedList();
                List varDecls = (List) val_peek(1).obj;
                Integer myLineNumber = popCurrentLineNumber("LocalVariableDeclarationStatement");
                Iterator itr = varDecls.iterator();
                while (itr.hasNext()) {
                    DeclaratorNode decl = (DeclaratorNode) itr.next();
                    int modifier = Modifier.NO_MOD;
                    int dims = decl.getDims();
                    NameNode name = decl.getName();
                    TreeNode init = decl.getInitExpr();
                    TypeNode type = TypeUtility.makeArrayType(
                            (TypeNode) val_peek(3).obj, dims);
                    LocalVarDeclNode node = new LocalVarDeclNode(modifier,
                            type, name, init);
                    node.setProperty(_LINENUMBER_KEY, myLineNumber);
                    result = cons(node, result);
                }
                yyval.obj = result;
            }
                break;
            case 292:
                //#line 1916 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 293:
                //#line 1918 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 294:
                //#line 1920 "Grammar.y"
            {
                yyval.obj = new ExprStmtNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 295:
                //#line 1925 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 296:
                //#line 1927 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 297:
                //#line 1929 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 298:
                //#line 1931 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 299:
                //#line 1933 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 300:
                //#line 1935 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 301:
                //#line 1937 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 302:
                //#line 1939 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 303:
                //#line 1946 "Grammar.y"
            {
                yyval.obj = new EmptyStmtNode();
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 304:
                //#line 1954 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledStatement");
            }
                break;
            case 305:
                //#line 1955 "Grammar.y"
            {
                if (_inConstraint)
                    yyerror("Labels cannot be used inside 'constraint' block");
                /*$$ = new LabeledStmtNode(new LocalLabelNode((NameNode) $1),*/
                yyval.obj = new LabeledStmtNode(new LocalLabelNode(
                        new NameNode(AbsentTreeNode.instance, val_peek(3).sval,
                                AbsentTreeNode.instance)),
                        (StatementNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledStatement"));
            }
                break;
            case 306:
                //#line 1965 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledStatement");
            }
                break;
            case 307:
                //#line 1966 "Grammar.y"
            {
                pushBlockEndLineNumber("LabeledBlock");
            }
                break;
            case 308:
                //#line 1967 "Grammar.y"
            {
                if (_inConstraint)
                    yyerror("Labels cannot be used inside 'constraint' block");
                yyval.obj = new LabeledBlockNode((List) val_peek(2).obj,
                        new LocalLabelNode((NameNode) val_peek(5).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledStatement"));
                ((TreeNode) yyval.obj).setProperty(_BLOCK_END_LINENUMBER_KEY,
                        popBlockEndLineNumber("LabeledBlock"));
            }
                break;
            case 309:
                //#line 1977 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledStatement");
            }
                break;
            case 310:
                //#line 1979 "Grammar.y"
            {
                pushBlockEndLineNumber("ActionLabel");
            }
                break;
            case 311:
                //#line 1980 "Grammar.y"
            {
                if (_inConstraint)
                    yyerror("Labels cannot be used inside 'constraint' block");
                List stmts = (List) val_peek(2).obj;
                if (stmts.size() == 0) {
                    yyerror("Can not label an empty statement.");
                } else if (stmts.size() == 1) {
                    if (stmts.get(0) instanceof AnnotationNode)
                        yyerror("Can not annotate an empty statement.");
                } else if (stmts.size() == 2) {
                    if (!((stmts.get(0) instanceof AnnotationNode) && (stmts
                            .get(1) instanceof StatementNode))
                            && !((stmts.get(1) instanceof AnnotationNode) && (stmts
                                    .get(0) instanceof StatementNode))) {
                        yyerror("Labels can enclose at most one statement and one annotation.");
                    }
                } else {
                    yyerror("Labels can enclose at most one statement and one annotation.");
                }
                yyval.obj = new ActionLabelStmtNode(new LocalLabelNode(
                        (NameNode) val_peek(5).obj), (List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledStatement"));
                ((TreeNode) yyval.obj).setProperty(_BLOCK_END_LINENUMBER_KEY,
                        popBlockEndLineNumber("ActionLabel"));
            }
                break;
            case 312:
                //#line 2006 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledStatement");
                _inAnnotation = true;
            }
                break;
            case 313:
                //#line 2008 "Grammar.y"
            {
                _inAnnotation = false;
                yyval.obj = new AnnotationNode((List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledStatement"));
            }
                break;
            case 314:
                //#line 2013 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledStatement");
            }
                break;
            case 315:
                //#line 2015 "Grammar.y"
            {
                if (!_inAnnotation) {
                    yyerror("beg{...} cannot be used outside annotation ({$...$}) block");
                }
                yyval.obj = new BeginAnnotationNode((List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledStatement"));
            }
                break;
            case 316:
                //#line 2022 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledStatement");
            }
                break;
            case 317:
                //#line 2024 "Grammar.y"
            {
                if (!_inAnnotation) {
                    yyerror("end{...} cannot be used outside annotation ({$...$}) block");
                }
                yyval.obj = new EndAnnotationNode((List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledStatement"));
            }
                break;
            case 318:
                //#line 2037 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 319:
                //#line 2039 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 320:
                //#line 2041 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 321:
                //#line 2043 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 322:
                //#line 2045 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 323:
                //#line 2047 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 324:
                //#line 2049 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 325:
                //#line 2056 "Grammar.y"
            {
                yyval.obj = new IfStmtNode((ExprNode) val_peek(2).obj,
                        (StatementNode) val_peek(0).obj,
                        AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("SelectionStatement"));
            }
                break;
            case 326:
                //#line 2064 "Grammar.y"
            {
                yyval.obj = new IfStmtNode((ExprNode) val_peek(4).obj,
                        (StatementNode) val_peek(2).obj,
                        (TreeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("SelectionStatement"));
            }
                break;
            case 327:
                //#line 2071 "Grammar.y"
            {
                yyval.obj = new SwitchNode((ExprNode) val_peek(2).obj,
                        (List) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("SelectionStatement"));
            }
                break;
            case 328:
                //#line 2077 "Grammar.y"
            {
                pushCurrentLineNumber("SelectionStatement");
            }
                break;
            case 329:
                //#line 2081 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 330:
                //#line 2086 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 331:
                //#line 2088 "Grammar.y"
            {
                yyval.obj = cons(new SwitchBranchNode((List) val_peek(2).obj,
                        (List) val_peek(1).obj), (List) val_peek(0).obj);
            }
                break;
            case 332:
                //#line 2092 "Grammar.y"
            {
                yyval.obj = cons(new SwitchBranchNode((List) val_peek(0).obj,
                        new LinkedList()));
            }
                break;
            case 333:
                //#line 2097 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 334:
                //#line 2099 "Grammar.y"
            {
                yyval.obj = cons(val_peek(1).obj, (List) val_peek(0).obj);
            }
                break;
            case 335:
                //#line 2103 "Grammar.y"
            {
                pushCurrentLineNumber("SwitchLabel");
            }
                break;
            case 336:
                //#line 2104 "Grammar.y"
            {
                yyval.obj = new CaseNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("SwitchLabel"));
            }
                break;
            case 337:
                //#line 2108 "Grammar.y"
            {
                pushCurrentLineNumber("SwitchLabel");
            }
                break;
            case 338:
                //#line 2109 "Grammar.y"
            {
                yyval.obj = new CaseNode(AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("SwitchLabel"));
            }
                break;
            case 339:
                //#line 2119 "Grammar.y"
            {
                yyval.obj = new LoopNode(new EmptyStmtNode(),
                        (ExprNode) val_peek(2).obj, (TreeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("IterationStatement"));
            }
                break;
            case 340:
                //#line 2128 "Grammar.y"
            {
                pushDoLoopTestLineNumber("DoLoop");
            }
                break;
            case 341:
                //#line 2129 "Grammar.y"
            {
                yyval.obj = new LoopNode((TreeNode) val_peek(6).obj,
                        (ExprNode) val_peek(3).obj, new EmptyStmtNode());
                Integer loopTestLineNumber = popDoLoopTestLineNumber("DoLoop");
                Object blockLineNumber = ((TreeNode) val_peek(6).obj)
                        .getProperty(_LINENUMBER_KEY);
                if (blockLineNumber == null
                        || blockLineNumber instanceof NullValue) {
                    ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                            loopTestLineNumber);
                } else {
                    ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                            (Integer) blockLineNumber);
                }
                ((TreeNode) yyval.obj).setProperty(_DOLOOP_TEST_LINENUMBER_KEY,
                        loopTestLineNumber);
            }
                break;
            case 342:
                //#line 2141 "Grammar.y"
            {
                yyval.obj = new ForNode((List) val_peek(5).obj,
                        (ExprNode) val_peek(4).obj, (List) val_peek(2).obj,
                        (StatementNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("IterationStatement"));
            }
                break;
            case 343:
                //#line 2148 "Grammar.y"
            {
                yyval.obj = new ForNode((List) val_peek(4).obj,
                        new BoolLitNode("true"), (List) val_peek(2).obj,
                        (StatementNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("IterationStatement"));
            }
                break;
            case 344:
                //#line 2155 "Grammar.y"
            {
                yyval.obj = new BoundedLoopNode((NameNode) val_peek(4).obj,
                        new IntLitNode(val_peek(2).sval),
                        (StatementNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("IterationStatement"));
            }
                break;
            case 345:
                //#line 2164 "Grammar.y"
            {
                pushCurrentLineNumber("IterationStatement");
            }
                break;
            case 346:
                //#line 2168 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 347:
                //#line 2170 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 348:
                //#line 2175 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 349:
                //#line 2177 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 350:
                //#line 2182 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 351:
                //#line 2184 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 352:
                //#line 2189 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 353:
                //#line 2191 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 354:
                //#line 2198 "Grammar.y"
            {
                yyval.obj = new BreakNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 355:
                //#line 2203 "Grammar.y"
            {
                yyval.obj = new ContinueNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 356:
                //#line 2208 "Grammar.y"
            {
                yyval.obj = new ReturnNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 357:
                //#line 2216 "Grammar.y"
            {
                yyval.obj = new LocalLabelNode((NameNode) val_peek(0).obj);
            }
                break;
            case 358:
                //#line 2218 "Grammar.y"
            {
                yyval.obj = AbsentTreeNode.instance;
            }
                break;
            case 359:
                //#line 2224 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintBlock");
            }
                break;
            case 360:
                //#line 2225 "Grammar.y"
            {
                if (_inConstraint)
                    yyerror("Cannot declare a 'constraint' block inside "
                            + "another 'constraint' block");
                _inConstraint = true;
            }
                break;
            case 361:
                //#line 2230 "Grammar.y"
            {
                _inConstraint = false;
            }
                break;
            case 362:
                //#line 2232 "Grammar.y"
            {
                yyval.obj = new ConstraintBlockNode((List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintBlock"));
            }
                break;
            case 363:
                //#line 2240 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 364:
                //#line 2242 "Grammar.y"
            {
                yyval.obj = appendLists((List) val_peek(1).obj,
                        (List) val_peek(0).obj);
            }
                break;
            case 365:
                //#line 2247 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 366:
                //#line 2249 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 367:
                //#line 2254 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 368:
                //#line 2257 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 369:
                //#line 2260 "Grammar.y"
            {
                if (!_inConstraint
                        && !(val_peek(2).obj instanceof LTLSynchNode)) {
                    yyerror("You must provide a name [a list of arguments] for "
                            + "defining ltl formulas outside constraints.");
                }
                LTLFormulaNode exp;
                if (val_peek(2).obj instanceof LTLFormulaNode) {
                    exp = (LTLFormulaNode) val_peek(2).obj;
                } else {
                    exp = new ExprLTLNode((ExprNode) val_peek(2).obj);
                }
                yyval.obj = new LTLConstraintNode((LTLFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 370:
                //#line 2276 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 371:
                //#line 2279 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 372:
                //#line 2282 "Grammar.y"
            {
                if (!_inConstraint
                        && !(val_peek(3).obj instanceof LTLSynchNode)) {
                    yyerror("You must provide a name [a list of arguments] for "
                            + "defining ltl formulas outside constraints.");
                }
                LTLFormulaNode exp;
                if (val_peek(3).obj instanceof LTLFormulaNode) {
                    exp = (LTLFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprLTLNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new LTLConstraintNode((LTLFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 373:
                //#line 2298 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 374:
                //#line 2301 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 375:
                //#line 2304 "Grammar.y"
            {
                LTLFormulaNode exp;
                if (val_peek(3).obj instanceof LTLFormulaNode) {
                    exp = (LTLFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprLTLNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new LTLConstraintDeclNode(
                        (NameNode) val_peek(8).obj, (List) new LinkedList(),
                        (LTLFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 376:
                //#line 2317 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 377:
                //#line 2320 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 378:
                //#line 2323 "Grammar.y"
            {
                LTLFormulaNode exp;
                if (val_peek(3).obj instanceof LTLFormulaNode)
                    exp = (LTLFormulaNode) val_peek(3).obj;
                else
                    exp = new ExprLTLNode((ExprNode) val_peek(3).obj);
                yyval.obj = new LTLConstraintDeclNode(
                        (NameNode) val_peek(9).obj, (List) val_peek(7).obj,
                        (LTLFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 379:
                //#line 2335 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                if (!_inConstraint) {
                    yyerror("'synch()' used outside a 'ltl()' statement.");
                }
                if (!_inNetlist) {
                    yyerror("'synch()' used outside a netlist.");
                }
                boolean hasEventImpl = false;
                Iterator eiter = ((List) val_peek(4).obj).iterator();
                while (eiter.hasNext()) {
                    ExprNode expr = (ExprNode) eiter.next();
                    if (expr instanceof ImplyNode) {
                        hasEventImpl = true;
                    } else if (!((expr instanceof EventNode)
                            || (expr instanceof ObjectNode) || (expr instanceof FieldAccessNode))) {
                        yyerror("Only events and event implication are allowed in synch().");
                    }
                }
                if (hasEventImpl) {
                    if (((List) val_peek(4).obj).size() > 1)
                        yyerror("Event implication can not co-exist with other events or event implications in one synch().");
                } else if (((List) val_peek(4).obj).size() < 2) {
                    yyerror("There should be at least two event references in synch().");
                }
                yyval.obj = new LTLSynchNode((List) val_peek(4).obj,
                        (List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 380:
                //#line 2365 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                if (!_inConstraint) {
                    yyerror("'synch()' used outside a 'ltl()' statement.");
                }
                if (!_inNetlist) {
                    yyerror("'synch()' used outside a netlist.");
                }
                boolean hasEventImpl = false;
                Iterator eiter = ((List) val_peek(2).obj).iterator();
                while (eiter.hasNext()) {
                    ExprNode expr = (ExprNode) eiter.next();
                    if (expr instanceof ImplyNode) {
                        hasEventImpl = true;
                    } else if (!((expr instanceof EventNode)
                            || (expr instanceof ObjectNode)
                            || (expr instanceof ArrayAccessNode) || (expr instanceof FieldAccessNode))) {
                        yyerror("There are non-event arguments in synch().");
                    }
                }
                if (hasEventImpl) {
                    if (((List) val_peek(2).obj).size() > 1)
                        yyerror("Event implication can not co-exist with other events or event implications in one synch().");
                } else if (((List) val_peek(2).obj).size() < 2) {
                    yyerror("There should be at least two event references in synch().");
                }
                yyval.obj = new LTLSynchNode((List) val_peek(2).obj,
                        new LinkedList());
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 381:
                //#line 2396 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 382:
                //#line 2400 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 383:
                //#line 2403 "Grammar.y"
            {
                if (!_inConstraint) {
                    yyerror("You must provide a name [a list of parameters] for "
                            + "defining loc formulas outside constraints.");
                }
                ActionFormulaNode exp;
                if (val_peek(2).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(2).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(2).obj);
                }
                yyval.obj = new LOCConstraintNode((ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 384:
                //#line 2419 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 385:
                //#line 2423 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 386:
                //#line 2426 "Grammar.y"
            {
                if (!_inConstraint) {
                    yyerror("You must provide a name [a list of parameters] for "
                            + "defining loc formulas outside constraints.");
                }
                ActionFormulaNode exp;
                if (val_peek(3).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new LOCConstraintNode((ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 387:
                //#line 2442 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;

                _inActionFormula = true;
            }
                break;
            case 388:
                //#line 2447 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 389:
                //#line 2450 "Grammar.y"
            {
                ActionFormulaNode exp;
                if (val_peek(3).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new LOCConstraintDeclNode(
                        (NameNode) val_peek(8).obj, (List) new LinkedList(),
                        (ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 390:
                //#line 2463 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 391:
                //#line 2467 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 392:
                //#line 2470 "Grammar.y"
            {
                ActionFormulaNode exp;
                if (val_peek(3).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new LOCConstraintDeclNode(
                        (NameNode) val_peek(9).obj, (List) val_peek(7).obj,
                        (ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 393:
                //#line 2483 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 394:
                //#line 2487 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 395:
                //#line 2490 "Grammar.y"
            {
                if (!_inConstraint) {
                    yyerror("You must provide a name [a list of arguments] for "
                            + "defining eloc formulas outside constraints.");
                }
                ActionFormulaNode exp;
                if (val_peek(3).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new ELOCConstraintNode((ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 396:
                //#line 2506 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 397:
                //#line 2510 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 398:
                //#line 2513 "Grammar.y"
            {
                ActionFormulaNode exp;
                if (val_peek(3).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new ELOCConstraintDeclNode(
                        (NameNode) val_peek(8).obj, (List) new LinkedList(),
                        (ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 399:
                //#line 2526 "Grammar.y"
            {
                pushCurrentLineNumber("ConstraintStatement");
                _inLTLFormula = true;
                _inActionFormula = true;
            }
                break;
            case 400:
                //#line 2530 "Grammar.y"
            {
                _inLTLFormula = false;
                _inActionFormula = false;
            }
                break;
            case 401:
                //#line 2533 "Grammar.y"
            {
                ActionFormulaNode exp;
                if (val_peek(3).obj instanceof ActionFormulaNode) {
                    exp = (ActionFormulaNode) val_peek(3).obj;
                } else {
                    exp = new ExprActionNode((ExprNode) val_peek(3).obj);
                }
                yyval.obj = new ELOCConstraintDeclNode(
                        (NameNode) val_peek(9).obj, (List) val_peek(7).obj,
                        (ActionFormulaNode) exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("ConstraintStatement"));
            }
                break;
            case 402:
                //#line 2549 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 403:
                //#line 2551 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj, (List) val_peek(2).obj);
            }
                break;
            case 404:
                //#line 2556 "Grammar.y"
            {
                DeclaratorNode decl = (DeclaratorNode) val_peek(0).obj;
                int dims = decl.getDims();
                NameNode name = decl.getName();
                TypeNode type = TypeUtility.makeArrayType(
                        (TypeNode) val_peek(1).obj, dims);
                yyval.obj = new ParameterNode(Modifier.NO_MOD, type, name);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 405:
                //#line 2568 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 406:
                //#line 2570 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 407:
                //#line 2575 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 408:
                //#line 2577 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 409:
                //#line 2582 "Grammar.y"
            {
                yyval.obj = new EqualVarsNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
            }
                break;
            case 410:
                //#line 2588 "Grammar.y"
            {
                pushCurrentLineNumber("AwaitStatement");
            }
                break;
            case 411:
                //#line 2590 "Grammar.y"
            {
                yyval.obj = new AwaitStatementNode((List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("AwaitStatement"));
            }
                break;
            case 412:
                //#line 2593 "Grammar.y"
            {
                pushCurrentLineNumber("AwaitStatement");
            }
                break;
            case 413:
                //#line 2594 "Grammar.y"
            {
                yyval.obj = new AwaitStatementNode(cons(val_peek(0).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("AwaitStatement"));
            }
                break;
            case 414:
                //#line 2601 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 415:
                //#line 2603 "Grammar.y"
            {
                yyval.obj = cons(val_peek(1).obj, (List) val_peek(0).obj);
            }
                break;
            case 416:
                //#line 2607 "Grammar.y"
            {
                pushCurrentLineNumber("AwaitGuard");
            }
                break;
            case 417:
                //#line 2609 "Grammar.y"
            {
                yyval.obj = new AwaitGuardNode((TreeNode) val_peek(7).obj,
                        (List) val_peek(4).obj, (List) val_peek(2).obj,
                        (StatementNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("AwaitGuard"));
            }
                break;
            case 418:
                //#line 2617 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 419:
                //#line 2619 "Grammar.y"
            {
                yyval.obj = AbsentTreeNode.instance;
            }
                break;
            case 420:
                //#line 2624 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 421:
                //#line 2626 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 422:
                //#line 2631 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 423:
                //#line 2633 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 424:
                //#line 2638 "Grammar.y"
            {
                yyval.obj = new AwaitLockNode(AbsentTreeNode.instance,
                        AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 425:
                //#line 2644 "Grammar.y"
            {
                yyval.obj = new AwaitLockNode(new ObjectNode(
                        (NameNode) val_peek(2).obj), (TreeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 426:
                //#line 2649 "Grammar.y"
            {
                yyval.obj = new AwaitLockNode(new ObjectNode(
                        (NameNode) val_peek(2).obj), AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 427:
                //#line 2655 "Grammar.y"
            {
                yyval.obj = new AwaitLockNode(new ThisNode(),
                        (TreeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 428:
                //#line 2660 "Grammar.y"
            {
                yyval.obj = new AwaitLockNode(new ThisNode(),
                        AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 429:
                //#line 2670 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'refine' used outside a netlist.");
                yyval.obj = new RefineNode((ExprNode) val_peek(4).obj,
                        (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 430:
                //#line 2677 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'connect' used outside a netlist.");
                yyval.obj = new ConnectNode((ExprNode) val_peek(6).obj,
                        (ExprNode) val_peek(4).obj, (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 431:
                //#line 2685 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'refineconnect' used outside a netlist.");
                yyval.obj = new RefineConnectNode((ExprNode) val_peek(8).obj,
                        (ExprNode) val_peek(6).obj, (ExprNode) val_peek(4).obj,
                        (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 432:
                //#line 2694 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'redirectconnect' used outside a netlist.");
                yyval.obj = new RedirectConnectNode(
                        (ExprNode) val_peek(10).obj,
                        (ExprNode) val_peek(8).obj, (ExprNode) val_peek(6).obj,
                        (ExprNode) val_peek(4).obj, (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 433:
                //#line 2703 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'addcomponent' used outside a netlist.");
                StringLitNode sln = new StringLitNode(new String(""));
                yyval.obj = new AddComponentNode((ExprNode) val_peek(4).obj,
                        (ExprNode) val_peek(2).obj, (ExprNode) sln);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 434:
                //#line 2711 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'addcomponent' used outside a netlist.");
                yyval.obj = new AddComponentNode((ExprNode) val_peek(6).obj,
                        (ExprNode) val_peek(4).obj, (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 435:
                //#line 2718 "Grammar.y"
            {
                if (!_inNetlist)
                    yyerror("'setscope' used outside a netlist.");
                yyval.obj = new SetScopeNode((ExprNode) val_peek(6).obj,
                        (ExprNode) val_peek(4).obj, (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 436:
                //#line 2733 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 437:
                //#line 2735 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 438:
                //#line 2740 "Grammar.y"
            {
                yyval.obj = new LocalLabelNode((NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 439:
                //#line 2748 "Grammar.y"
            {
                yyval.obj = new GlobalLabelNode((ExprNode) val_peek(3).obj,
                        (LocalLabelNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 440:
                //#line 2758 "Grammar.y"
            {
                if (!_inLTLFormula)
                    yyerror("LTL operator 'F()' used outside a 'ltl()' statement.");
                LTLFormulaNode exp;
                if (val_peek(1).obj instanceof LTLFormulaNode)
                    exp = (LTLFormulaNode) val_peek(1).obj;
                else
                    exp = new ExprLTLNode((ExprNode) val_peek(1).obj);
                yyval.obj = new FutureLTLNode(exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 441:
                //#line 2770 "Grammar.y"
            {
                if (!_inLTLFormula)
                    yyerror("LTL operator 'G()' used outside a 'ltl()' statement.");
                LTLFormulaNode exp;
                if (val_peek(1).obj instanceof LTLFormulaNode)
                    exp = (LTLFormulaNode) val_peek(1).obj;
                else
                    exp = new ExprLTLNode((ExprNode) val_peek(1).obj);
                yyval.obj = new GloballyLTLNode(exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 442:
                //#line 2782 "Grammar.y"
            {
                if (!_inLTLFormula)
                    yyerror("LTL operator 'X()' used outside a 'ltl()' statement.");
                LTLFormulaNode exp;
                if (val_peek(1).obj instanceof LTLFormulaNode)
                    exp = (LTLFormulaNode) val_peek(1).obj;
                else
                    exp = new ExprLTLNode((ExprNode) val_peek(1).obj);
                yyval.obj = new NextLTLNode(exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 443:
                //#line 2794 "Grammar.y"
            {
                if (!_inLTLFormula)
                    yyerror("LTL operator 'U' used outside a 'ltl()' statement.");
                LTLFormulaNode exp1, exp2;
                if (val_peek(2).obj instanceof LTLFormulaNode)
                    exp1 = (LTLFormulaNode) val_peek(2).obj;
                else
                    exp1 = new ExprLTLNode((ExprNode) val_peek(2).obj);
                if (val_peek(0).obj instanceof LTLFormulaNode)
                    exp2 = (LTLFormulaNode) val_peek(0).obj;
                else
                    exp2 = new ExprLTLNode((ExprNode) val_peek(0).obj);
                yyval.obj = new UntilLTLNode(exp1, exp2);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 444:
                //#line 2810 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 445:
                //#line 2812 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("Named loc formulas can only be used inside a "
                            + "constraint statement");
                yyval.obj = new LTLConstraintCallNode(
                        (NameNode) val_peek(3).obj, (List) new LinkedList());
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 446:
                //#line 2821 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("Named loc formulas can only be used inside a "
                            + "constraint statement");
                yyval.obj = new LTLConstraintCallNode(
                        (NameNode) val_peek(4).obj, (List) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 447:
                //#line 2834 "Grammar.y"
            {
                if (!_inLTLFormula) {
                    yyerror("LTL formula 'excl' used outside a 'ltl()' statement.");
                }
                if (!((val_peek(3).obj instanceof EventNode)
                        || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))
                        || !((val_peek(1).obj instanceof EventNode)
                                || (val_peek(1).obj instanceof ObjectNode) || (val_peek(1).obj instanceof FieldAccessNode))) {
                    yyerror("Both expressions in excl() must be event references.");
                }
                yyval.obj = new ExclLTLNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 448:
                //#line 2850 "Grammar.y"
            {
                if (!_inLTLFormula) {
                    yyerror("LTL formula 'mutex' used outside a 'ltl()' statement.");
                }
                if (!((val_peek(3).obj instanceof EventNode)
                        || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))
                        || !((val_peek(1).obj instanceof EventNode)
                                || (val_peek(1).obj instanceof ObjectNode) || (val_peek(1).obj instanceof FieldAccessNode))) {
                    yyerror("Both expressions in mutex() must be event references.");
                }
                yyval.obj = new MutexLTLNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 449:
                //#line 2866 "Grammar.y"
            {
                if (!_inLTLFormula) {
                    yyerror("LTL formula 'simul' used outside a 'ltl()' statement.");
                }
                if (!((val_peek(3).obj instanceof EventNode)
                        || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))
                        || !((val_peek(1).obj instanceof EventNode)
                                || (val_peek(1).obj instanceof ObjectNode) || (val_peek(1).obj instanceof FieldAccessNode))) {
                    yyerror("Both expressions in simul() must be event references.");
                }
                yyval.obj = new SimulLTLNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 450:
                //#line 2882 "Grammar.y"
            {
                if (!_inLTLFormula) {
                    yyerror("LTL formula 'priority' used outside a 'ltl()' statement.");
                }
                if (!((val_peek(5).obj instanceof EventNode)
                        || (val_peek(5).obj instanceof ObjectNode) || (val_peek(5).obj instanceof FieldAccessNode))
                        || !((val_peek(3).obj instanceof EventNode)
                                || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))) {
                    yyerror("The first two expressions in priority() must be "
                            + "event references.");
                }
                yyval.obj = new PriorityLTLNode((ExprNode) val_peek(5).obj,
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 451:
                //#line 2904 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("Action formula 'forall' used outside a 'lfo()', "
                            + "'loc()' and 'eloc()' statetments.");
                }
                ActionFormulaNode exp;
                if (val_peek(0).obj instanceof ActionFormulaNode)
                    exp = (ActionFormulaNode) val_peek(0).obj;
                else
                    exp = new ExprActionNode((ExprNode) val_peek(0).obj);
                yyval.obj = new ForallActionNode((List) val_peek(2).obj, exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 452:
                //#line 2918 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("Action formula 'exists' used outside a 'lfo()', "
                            + "'loc()' and 'eloc()' statetments.");
                }
                ActionFormulaNode exp;
                if (val_peek(0).obj instanceof ActionFormulaNode)
                    exp = (ActionFormulaNode) val_peek(0).obj;
                else
                    exp = new ExprActionNode((ExprNode) val_peek(0).obj);
                yyval.obj = new ExistsActionNode((List) val_peek(2).obj, exp);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 453:
                //#line 2932 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 454:
                //#line 2934 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("Named loc formulas can only be used inside a "
                            + "constraint statement");
                yyval.obj = new LOCConstraintCallNode(
                        (NameNode) val_peek(2).obj, (List) new LinkedList());
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 455:
                //#line 2943 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("Named loc formulas can only be used inside a "
                            + "constraint statement");
                yyval.obj = new LOCConstraintCallNode(
                        (NameNode) val_peek(3).obj, (List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 456:
                //#line 2952 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("Named eloc formulas can only be used inside a "
                            + "constraint statement");
                yyval.obj = new ELOCConstraintCallNode(
                        (NameNode) val_peek(2).obj, (List) new LinkedList());
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 457:
                //#line 2961 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("Named eloc formulas can only be used inside a "
                            + "constraint statement");
                yyval.obj = new ELOCConstraintCallNode(
                        (NameNode) val_peek(3).obj, (List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 458:
                //#line 2973 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("'maxdelta' used outside a 'loc' statetment.");
                }
                if (!((val_peek(5).obj instanceof EventNode)
                        || (val_peek(5).obj instanceof ObjectNode) || (val_peek(5).obj instanceof FieldAccessNode))
                        || !((val_peek(3).obj instanceof EventNode)
                                || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))) {
                    yyerror("The 2nd and 3rd arguments in maxdelta() must be "
                            + "event references.");
                }
                yyval.obj = new MaxDeltaNode((ExprNode) val_peek(7).obj,
                        (ExprNode) val_peek(5).obj, (ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 459:
                //#line 2991 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("'mindelta' used outside a 'loc' statetment.");
                }
                if (!((val_peek(5).obj instanceof EventNode)
                        || (val_peek(5).obj instanceof ObjectNode) || (val_peek(5).obj instanceof FieldAccessNode))
                        || !((val_peek(3).obj instanceof EventNode)
                                || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))) {
                    yyerror("The 2nd and 3rd arguments in mindelta() must be "
                            + "event references.");
                }
                yyval.obj = new MinDeltaNode((ExprNode) val_peek(7).obj,
                        (ExprNode) val_peek(5).obj, (ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 460:
                //#line 3009 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("'maxrate' used outside a 'loc' statetment.");
                }
                if (!((val_peek(3).obj instanceof EventNode)
                        || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))) {
                    yyerror("The 2nd argument in maxrate() must be an event reference.");
                }
                yyval.obj = new MaxRateNode((ExprNode) val_peek(5).obj,
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 461:
                //#line 3022 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("'minrate' used outside a 'loc' statetment.");
                }
                if (!((val_peek(3).obj instanceof EventNode)
                        || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))) {
                    yyerror("The 2nd argument in minrate() must be an event reference.");
                }
                yyval.obj = new MinRateNode((ExprNode) val_peek(5).obj,
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 462:
                //#line 3035 "Grammar.y"
            {
                if (!_inActionFormula) {
                    yyerror("'period' used outside a 'loc' statetment.");
                }
                if (!((val_peek(3).obj instanceof EventNode)
                        || (val_peek(3).obj instanceof ObjectNode) || (val_peek(3).obj instanceof FieldAccessNode))) {
                    yyerror("The 2nd argument in minrate() must be an event reference.");
                }
                yyval.obj = new PeriodNode((ExprNode) val_peek(5).obj,
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 463:
                //#line 3054 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) AbsentTreeNode.instance,
                        (TreeNode) AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 464:
                //#line 3060 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) new ThisNode(),
                        (NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 465:
                //#line 3065 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) val_peek(2).obj,
                        (NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 466:
                //#line 3070 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) val_peek(2).obj,
                        (NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 467:
                //#line 3075 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) val_peek(2).obj,
                        (NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 468:
                //#line 3080 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) val_peek(2).obj,
                        (NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 469:
                //#line 3085 "Grammar.y"
            {
                yyval.obj = new ActionNode((TreeNode) val_peek(2).obj,
                        (NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 470:
                //#line 3097 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 471:
                //#line 3099 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 472:
                //#line 3101 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 473:
                //#line 3108 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 474:
                //#line 3110 "Grammar.y"
            {
                yyval.obj = AbsentTreeNode.instance;
            }
                break;
            case 475:
                //#line 3115 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 476:
                //#line 3117 "Grammar.y"
            {
                yyval.obj = new MultNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 477:
                //#line 3122 "Grammar.y"
            {
                yyval.obj = new DivNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 478:
                //#line 3127 "Grammar.y"
            {
                yyval.obj = new RemNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 479:
                //#line 3132 "Grammar.y"
            {
                yyval.obj = new PlusNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 480:
                //#line 3137 "Grammar.y"
            {
                yyval.obj = new MinusNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 481:
                //#line 3142 "Grammar.y"
            {
                yyval.obj = new LeftShiftLogNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 482:
                //#line 3147 "Grammar.y"
            {
                yyval.obj = new RightShiftLogNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 483:
                //#line 3152 "Grammar.y"
            {
                yyval.obj = new RightShiftArithNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 484:
                //#line 3157 "Grammar.y"
            {
                yyval.obj = new LTNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 485:
                //#line 3162 "Grammar.y"
            {
                yyval.obj = new GTNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 486:
                //#line 3167 "Grammar.y"
            {
                yyval.obj = new LENode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 487:
                //#line 3172 "Grammar.y"
            {
                yyval.obj = new GENode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 488:
                //#line 3177 "Grammar.y"
            {
                yyval.obj = new InstanceOfNode((ExprNode) val_peek(2).obj,
                        (TypeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 489:
                //#line 3182 "Grammar.y"
            {
                yyval.obj = new EQNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 490:
                //#line 3187 "Grammar.y"
            {
                yyval.obj = new NENode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 491:
                //#line 3192 "Grammar.y"
            {
                yyval.obj = new BitAndNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 492:
                //#line 3197 "Grammar.y"
            {
                yyval.obj = new BitOrNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 493:
                //#line 3202 "Grammar.y"
            {
                yyval.obj = new BitXorNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 494:
                //#line 3207 "Grammar.y"
            {
                yyval.obj = new CandNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 495:
                //#line 3212 "Grammar.y"
            {
                yyval.obj = new CorNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 496:
                //#line 3217 "Grammar.y"
            {
                yyval.obj = new CifNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 497:
                //#line 3222 "Grammar.y"
            {
                yyval.obj = new CiffNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 498:
                //#line 3227 "Grammar.y"
            {
                yyval.obj = new IfExprNode((ExprNode) val_peek(4).obj,
                        (ExprNode) val_peek(2).obj, (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 499:
                //#line 3232 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 500:
                //#line 3234 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 501:
                //#line 3236 "Grammar.y"
            { /*if (!(($1 instanceof EventNode) || ($1 instanceof ObjectNode)*/
                /* || ($1 instanceof FieldAccessNode)))*/
                /*yyerror("Expression before a '=>' must be an event reference.");*/
                yyval.obj = new ImplyNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 502:
                //#line 3249 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 503:
                //#line 3252 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledExpression");
                _inAnnotation = true;
            }
                break;
            case 504:
                //#line 3254 "Grammar.y"
            {
                _inAnnotation = false;
                AnnotationNode anode = new AnnotationNode(
                        (List) val_peek(2).obj);
                ((TreeNode) anode).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledExpression"));
                ((ActionLabelExprNode) val_peek(5).obj)
                        .setAnode((TreeNode) anode);
                yyval.obj = val_peek(5).obj;
            }
                break;
            case 505:
                //#line 3266 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledExpressionFirst");
                _inExprLabel++;
                if (_inExprLabel > 1) {
                    yyerror("Nested expression labels are disallowed.");
                }
            }
                break;
            case 506:
                //#line 3273 "Grammar.y"
            {
                _inExprLabel--;
                if (_inConstraint)
                    yyerror("Labels cannot be used inside 'constraint' block");
                yyval.obj = new ActionLabelExprNode(new LocalLabelNode(
                        (NameNode) val_peek(3).obj),
                        (ExprNode) val_peek(0).obj, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledExpressionFirst"));
            }
                break;
            case 507:
                //#line 3283 "Grammar.y"
            {
                pushCurrentLineNumber("LabeledExpressionFirst");
                _inExprLabel++;
                if (_inExprLabel > 1)
                    yyerror("Nested expression labels are disallowed.");
            }
                break;
            case 508:
                //#line 3288 "Grammar.y"
            {
                _inLineNumber1 = _lexer.lineNumber();
                _inAnnotation = true;
            }
                break;
            case 509:
                //#line 3291 "Grammar.y"
            {
                _inAnnotation = false;
                AnnotationNode anode = new AnnotationNode(
                        (List) val_peek(2).obj);
                ((TreeNode) anode).setProperty(_LINENUMBER_KEY, new Integer(
                        _inLineNumber1));
                _inExprLabel--;
                if (_inConstraint)
                    yyerror("Labels cannot be used inside 'constraint' block");
                yyval.obj = new ActionLabelExprNode(new LocalLabelNode(
                        (NameNode) val_peek(7).obj),
                        (ExprNode) val_peek(0).obj, (TreeNode) anode);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        popCurrentLineNumber("LabeledExpressionFirst"));
            }
                break;
            case 510:
                //#line 3311 "Grammar.y"
            {
                yyval.obj = new AssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 511:
                //#line 3316 "Grammar.y"
            {
                yyval.obj = new MultAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 512:
                //#line 3321 "Grammar.y"
            {
                yyval.obj = new DivAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 513:
                //#line 3326 "Grammar.y"
            {
                yyval.obj = new RemAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 514:
                //#line 3331 "Grammar.y"
            {
                yyval.obj = new PlusAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 515:
                //#line 3336 "Grammar.y"
            {
                yyval.obj = new MinusAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 516:
                //#line 3341 "Grammar.y"
            {
                yyval.obj = new LeftShiftLogAssignNode(
                        (ExprNode) val_peek(2).obj, (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 517:
                //#line 3346 "Grammar.y"
            {
                yyval.obj = new RightShiftLogAssignNode(
                        (ExprNode) val_peek(2).obj, (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 518:
                //#line 3351 "Grammar.y"
            {
                yyval.obj = new RightShiftArithAssignNode(
                        (ExprNode) val_peek(2).obj, (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 519:
                //#line 3356 "Grammar.y"
            {
                yyval.obj = new BitAndAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 520:
                //#line 3361 "Grammar.y"
            {
                yyval.obj = new BitXorAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 521:
                //#line 3366 "Grammar.y"
            {
                yyval.obj = new BitOrAssignNode((ExprNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 522:
                //#line 3376 "Grammar.y"
            {
                yyval.obj = new ObjectNode((NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 523:
                //#line 3381 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 524:
                //#line 3383 "Grammar.y"
            {
                yyval.obj = new TypeClassAccessNode(new TypeNameNode(
                        (NameNode) val_peek(2).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 525:
                //#line 3388 "Grammar.y"
            {
                yyval.obj = new TypeClassAccessNode((TypeNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 526:
                //#line 3393 "Grammar.y"
            {
                yyval.obj = new TypeClassAccessNode((TypeNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 527:
                //#line 3398 "Grammar.y"
            {
                yyval.obj = new OuterThisAccessNode(new TypeNameNode(
                        (NameNode) val_peek(2).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 528:
                //#line 3403 "Grammar.y"
            {
                yyval.obj = new OuterSuperAccessNode(new TypeNameNode(
                        (NameNode) val_peek(2).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 529:
                //#line 3411 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 530:
                //#line 3413 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 531:
                //#line 3418 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 532:
                //#line 3420 "Grammar.y"
            {
                yyval.obj = new NullPntrNode();
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 533:
                //#line 3425 "Grammar.y"
            {
                yyval.obj = new ThisNode();
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 534:
                //#line 3430 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 535:
                //#line 3432 "Grammar.y"
            {
                yyval.obj = new ObjectNode((NameNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 536:
                //#line 3437 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 537:
                //#line 3439 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 538:
                //#line 3441 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 539:
                //#line 3443 "Grammar.y"
            {
                yyval.obj = new TypeClassAccessNode((TypeNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 540:
                //#line 3448 "Grammar.y"
            {
                yyval.obj = (EventNode) val_peek(0).obj;
            }
                break;
            case 541:
                //#line 3450 "Grammar.y"
            {
                yyval.obj = (EventNode) val_peek(0).obj;
            }
                break;
            case 542:
                //#line 3452 "Grammar.y"
            {
                yyval.obj = (EventNode) val_peek(0).obj;
            }
                break;
            case 543:
                //#line 3454 "Grammar.y"
            {
                yyval.obj = (EventNode) val_peek(0).obj;
            }
                break;
            case 544:
                //#line 3465 "Grammar.y"
            {
                yyval.obj = new ArrayAccessNode(new ObjectNode(
                        (NameNode) val_peek(3).obj), (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 545:
                //#line 3471 "Grammar.y"
            {
                yyval.obj = new ArrayAccessNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 546:
                //#line 3482 "Grammar.y"
            {
                yyval.obj = new ObjectFieldAccessNode(
                        (NameNode) val_peek(0).obj, (ExprNode) val_peek(2).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 547:
                //#line 3487 "Grammar.y"
            {
                yyval.obj = new SuperFieldAccessNode((NameNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 548:
                //#line 3497 "Grammar.y"
            {
                yyval.obj = new MethodCallNode(new ObjectNode(
                        (NameNode) val_peek(3).obj), (List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 549:
                //#line 3502 "Grammar.y"
            {
                yyval.obj = new MethodCallNode(
                        (FieldAccessNode) val_peek(3).obj,
                        (List) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 550:
                //#line 3510 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 551:
                //#line 3512 "Grammar.y"
            {
                yyval.obj = new LinkedList();
            }
                break;
            case 552:
                //#line 3517 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 553:
                //#line 3519 "Grammar.y"
            {
                yyval.obj = cons(val_peek(2).obj, (List) val_peek(0).obj);
            }
                break;
            case 557:
                //#line 3532 "Grammar.y"
            {
                yyval.obj = new PostIncrNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 558:
                //#line 3540 "Grammar.y"
            {
                yyval.obj = new PostDecrNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 561:
                //#line 3552 "Grammar.y"
            {
                yyval.obj = new UnaryPlusNode((ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 562:
                //#line 3557 "Grammar.y"
            {
                yyval.obj = new UnaryMinusNode((ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 563:
                //#line 3562 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 564:
                //#line 3567 "Grammar.y"
            {
                yyval.obj = new PreIncrNode((ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 565:
                //#line 3575 "Grammar.y"
            {
                yyval.obj = new PreDecrNode((ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 566:
                //#line 3583 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 567:
                //#line 3585 "Grammar.y"
            {
                yyval.obj = new ComplementNode((ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 568:
                //#line 3590 "Grammar.y"
            {
                yyval.obj = new NotNode((ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 569:
                //#line 3595 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 570:
                //#line 3597 "Grammar.y"
            {
                yyval.obj = new ExecIndexNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 571:
                //#line 3602 "Grammar.y"
            {
                yyval.obj = new NonDeterminismNode(
                        (PrimitiveTypeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 572:
                //#line 3607 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("'pc(PROCESS)' can only be used inside a constraint "
                            + "statement");
                yyval.obj = new PCNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 573:
                //#line 3615 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("'beg(LABEL)' can only be used inside a constraint "
                            + "statement");
                yyval.obj = new BeginPCNode((LabelNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 574:
                //#line 3623 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("'end(LABEL)' can only be used inside a constraint "
                            + "statement");
                yyval.obj = new EndPCNode((LabelNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 575:
                //#line 3631 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getconnectionnum' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetConnectionNumNode(
                        (ExprNode) val_peek(3).obj, (NameNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 576:
                //#line 3639 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getconnectionnum' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetConnectionNumNode(
                        (ExprNode) val_peek(3).obj, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 577:
                //#line 3647 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getnthconnectionport' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetNthConnectionPortNode(
                        (ExprNode) val_peek(5).obj, (NameNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 578:
                //#line 3655 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getnthport' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetNthPortNode((ExprNode) val_peek(5).obj,
                        (NameNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 579:
                //#line 3663 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getportnum' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetPortNumNode((ExprNode) val_peek(3).obj,
                        (NameNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 580:
                //#line 3671 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getnthconnectionsrc' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetScopeNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 581:
                //#line 3679 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getcompname' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetCompNameNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 582:
                //#line 3687 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getinstname' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetInstNameNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 583:
                //#line 3695 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'isconnectionrefined' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new IsConnectionRefinedNode(
                        (ExprNode) val_peek(5).obj, (ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 584:
                //#line 3704 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'gettype' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetTypeNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 585:
                //#line 3712 "Grammar.y"
            {
                if (!_inConstraint && !_inAnnotation && !_inMethod)
                    yyerror("'getprocess' should be used inside a constraint, "
                            + "annotation or a method.");
                if (!((val_peek(1).obj instanceof EventNode)
                        || (val_peek(1).obj instanceof ObjectNode) || (val_peek(1).obj instanceof FieldAccessNode))) {
                    yyerror("The argument in getprocess() must be an event reference.");
                }
                yyval.obj = new GetProcessNode((ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 586:
                //#line 3725 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 587:
                //#line 3727 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 588:
                //#line 3729 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 589:
                //#line 3731 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 590:
                //#line 3733 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 591:
                //#line 3738 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("'var@(Event, index)' can only be used inside a "
                            + "constraint statement");
                yyval.obj = new VarInEventRefNode((ExprNode) val_peek(6).obj,
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 592:
                //#line 3747 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("'var@(Event, index)' can only be used inside a "
                            + "constraint statement");
                yyval.obj = new VarInEventRefNode((ExprNode) (new ObjectNode(
                        (NameNode) val_peek(6).obj)),
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 593:
                //#line 3756 "Grammar.y"
            {
                if (!_inConstraint)
                    yyerror("'var@(Event, index)' can only be used inside a "
                            + "constraint statement");
                yyval.obj = new VarInEventRefNode((ExprNode) val_peek(6).obj,
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 594:
                //#line 3768 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getcomponent' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetComponentNode((ExprNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 595:
                //#line 3779 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getnthconnectionsrc' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetNthConnectionSrcNode(
                        (ExprNode) val_peek(5).obj, (NameNode) val_peek(3).obj,
                        (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 596:
                //#line 3791 "Grammar.y"
            {
                if (!_inNetlist && !_inConstraint && !_inAnnotation)
                    yyerror("'getnthconnectionsrc' should be used inside a netlist"
                            + ", a constraint block or an annotation.");
                yyval.obj = new GetConnectionDestNode(
                        (ExprNode) val_peek(3).obj, (ExprNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 597:
                //#line 3802 "Grammar.y"
            { /* if (!_inConstraint && !_inAnnotation)
             yyerror("'getthread' should be used inside "
             +"a constraint block or an annotation."); */
                yyval.obj = new GetThreadNode();
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 598:
                //#line 3815 "Grammar.y"
            {
                yyval.obj = new BeginEventNode(
                        (TreeNode) AbsentTreeNode.instance,
                        (ActionNode) val_peek(1).obj);
            }
                break;
            case 599:
                //#line 3818 "Grammar.y"
            {
                yyval.obj = new BeginEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 600:
                //#line 3823 "Grammar.y"
            {
                yyval.obj = new BeginEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 601:
                //#line 3828 "Grammar.y"
            {
                yyval.obj = new BeginEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 602:
                //#line 3833 "Grammar.y"
            {
                yyval.obj = new BeginEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 603:
                //#line 3838 "Grammar.y"
            {
                yyval.obj = new BeginEventNode((TreeNode) new ThisNode(),
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 604:
                //#line 3846 "Grammar.y"
            {
                yyval.obj = new EndEventNode(
                        (TreeNode) AbsentTreeNode.instance,
                        (ActionNode) val_peek(1).obj);
            }
                break;
            case 605:
                //#line 3849 "Grammar.y"
            {
                yyval.obj = new EndEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 606:
                //#line 3854 "Grammar.y"
            {
                yyval.obj = new EndEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 607:
                //#line 3859 "Grammar.y"
            {
                yyval.obj = new EndEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 608:
                //#line 3864 "Grammar.y"
            {
                yyval.obj = new EndEventNode((TreeNode) val_peek(3).obj,
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 609:
                //#line 3869 "Grammar.y"
            {
                yyval.obj = new EndEventNode((TreeNode) new ThisNode(),
                        (ActionNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 610:
                //#line 3877 "Grammar.y"
            {
                yyval.obj = new NoneEventNode(
                        (TreeNode) AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 611:
                //#line 3882 "Grammar.y"
            {
                yyval.obj = new NoneEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 612:
                //#line 3887 "Grammar.y"
            {
                yyval.obj = new NoneEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 613:
                //#line 3892 "Grammar.y"
            {
                yyval.obj = new NoneEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 614:
                //#line 3897 "Grammar.y"
            {
                yyval.obj = new NoneEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 615:
                //#line 3905 "Grammar.y"
            {
                yyval.obj = new OtherEventNode(
                        (TreeNode) AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 616:
                //#line 3910 "Grammar.y"
            {
                yyval.obj = new OtherEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 617:
                //#line 3915 "Grammar.y"
            {
                yyval.obj = new OtherEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 618:
                //#line 3920 "Grammar.y"
            {
                yyval.obj = new OtherEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 619:
                //#line 3925 "Grammar.y"
            {
                yyval.obj = new OtherEventNode((TreeNode) val_peek(1).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 620:
                //#line 3933 "Grammar.y"
            {
                yyval.obj = new CastNode((TypeNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 621:
                //#line 3938 "Grammar.y"
            {
                yyval.obj = new CastNode((TypeNode) val_peek(2).obj,
                        (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 622:
                //#line 3943 "Grammar.y"
            {
                yyval.obj = new CastNode(new TypeNameNode(
                        (NameNode) val_peek(2).obj), (ExprNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 623:
                //#line 3956 "Grammar.y"
            {
                yyval.obj = cons(val_peek(0).obj);
            }
                break;
            case 624:
                //#line 3958 "Grammar.y"
            {
                yyval.obj = cons(val_peek(1).obj, (List) val_peek(0).obj);
            }
                break;
            case 625:
                //#line 3963 "Grammar.y"
            {
                yyval.obj = val_peek(1).obj;
            }
                break;
            case 626:
                //#line 3967 "Grammar.y"
            {
            }
                break;
            case 627:
                //#line 3969 "Grammar.y"
            {
                yyval.ival = 0;
            }
                break;
            case 628:
                //#line 3974 "Grammar.y"
            {
                yyval.ival = 1;
            }
                break;
            case 629:
                //#line 3976 "Grammar.y"
            {
                yyval.ival = val_peek(1).ival + 1;
            }
                break;
            case 630:
                //#line 3984 "Grammar.y"
            {
                yyval.obj = val_peek(0).obj;
            }
                break;
            case 631:
                //#line 3991 "Grammar.y"
            {
                yyval.obj = new AllocateNode((TypeNameNode) val_peek(3).obj,
                        (List) val_peek(1).obj, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 632:
                //#line 3998 "Grammar.y"
            {
                yyval.obj = new AllocateAnonymousClassNode(
                        (TypeNameNode) val_peek(4).obj, (List) val_peek(2).obj,
                        (List) val_peek(0).obj, AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 633:
                //#line 4004 "Grammar.y"
            {
                yyval.obj = new AllocateArrayNode((TypeNode) val_peek(2).obj,
                        (List) val_peek(1).obj, val_peek(0).ival,
                        AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 634:
                //#line 4011 "Grammar.y"
            {
                yyval.obj = new AllocateArrayNode((TypeNode) val_peek(2).obj,
                        new LinkedList(), val_peek(1).ival,
                        (TreeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 635:
                //#line 4017 "Grammar.y"
            {
                yyval.obj = new AllocateArrayNode((TypeNode) val_peek(2).obj,
                        (List) val_peek(1).obj, val_peek(0).ival,
                        AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 636:
                //#line 4023 "Grammar.y"
            {
                yyval.obj = new AllocateArrayNode((TypeNode) val_peek(2).obj,
                        (List) val_peek(1).obj, val_peek(0).ival,
                        AbsentTreeNode.instance);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 637:
                //#line 4030 "Grammar.y"
            {
                yyval.obj = new AllocateArrayNode((TypeNode) val_peek(2).obj,
                        new LinkedList(), val_peek(1).ival,
                        (TreeNode) val_peek(0).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 638:
                //#line 4037 "Grammar.y"
            {
                yyval.obj = new AllocateNode(new TypeNameNode(new NameNode(
                        AbsentTreeNode.instance, val_peek(3).sval,
                        AbsentTreeNode.instance)), (List) val_peek(1).obj,
                        (ExprNode) val_peek(6).obj);
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 639:
                //#line 4045 "Grammar.y"
            {
                yyval.obj = new AllocateAnonymousClassNode(new TypeNameNode(
                        new NameNode(AbsentTreeNode.instance, val_peek(4).sval,
                                AbsentTreeNode.instance)),
                        (List) val_peek(2).obj, (List) val_peek(0).obj,
                        (ExprNode) val_peek(7).obj);

                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 640:
                //#line 4056 "Grammar.y"
            {
                yyval.obj = new AllocateNode(new TypeNameNode(new NameNode(
                        AbsentTreeNode.instance, val_peek(3).sval,
                        AbsentTreeNode.instance)), (List) val_peek(1).obj,
                        new ObjectNode((NameNode) val_peek(6).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            case 641:
                //#line 4064 "Grammar.y"
            {
                yyval.obj = new AllocateAnonymousClassNode(new TypeNameNode(
                        new NameNode(AbsentTreeNode.instance, val_peek(4).sval,
                                AbsentTreeNode.instance)),
                        (List) val_peek(2).obj, (List) val_peek(0).obj,
                        new ObjectNode((NameNode) val_peek(7).obj));
                ((TreeNode) yyval.obj).setProperty(_LINENUMBER_KEY,
                        new Integer(_lexer.lineNumber()));
            }
                break;
            //#line 9859 "MetaModelParser.java"
            //########## END OF USER-SUPPLIED ACTIONS ##########
            }//switch
            //#### Now let's reduce... ####
            if (yydebug)
                debug("reduce");
            state_drop(yym); //we just reduced yylen states
            yystate = state_peek(0); //get new state
            val_drop(yym); //corresponding value drop
            yym = yylhs[yyn]; //select next TERMINAL(on lhs)
            if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
            {
                debug("After reduction, shifting from state 0 to state "
                        + YYFINAL + "");
                yystate = YYFINAL; //explicitly say we're done
                state_push(YYFINAL); //and save it
                val_push(yyval); //also save the semantic value of parsing
                if (yychar < 0) //we want another character?
                {
                    yychar = yylex(); //get next character
                    if (yychar < 0)
                        yychar = 0; //clean, if necessary
                    if (yydebug)
                        yylexdebug(yystate, yychar);
                }
                if (yychar == 0) //Good exit (if lex returns 0 ;-)
                    break; //quit the loop--all DONE
            }//if yystate
            else //else not done yet
            { //get next state and push, for next yydefred[]
                yyn = yygindex[yym]; //find out where to go
                if ((yyn != 0) && (yyn += yystate) >= 0 && yyn <= YYTABLESIZE
                        && yycheck[yyn] == yystate)
                    yystate = yytable[yyn]; //get new state
                else
                    yystate = yydgoto[yym]; //else go to new defred
                debug("after reduction, shifting from state " + state_peek(0)
                        + " to state " + yystate + "");
                state_push(yystate); //going again, so push state & val...
                val_push(yyval); //for next action
            }
        }//main loop
        return 0;//yyaccept!!
    }
    //## end of method parse() ######################################

}
//################### END OF CLASS yaccpar ######################
